]>
Commit | Line | Data |
---|---|---|
8d876415 DK |
1 | #!/bin/sh -- # no runable script, just for vi |
2 | ||
5d76cee1 | 3 | EXIT_CODE=0 |
8c1dd12c | 4 | |
68042532 DK |
5 | while [ -n "$1" ]; do |
6 | if [ "$1" = "-q" ]; then | |
7 | export MSGLEVEL=2 | |
8 | elif [ "$1" = "-v" ]; then | |
9 | export MSGLEVEL=4 | |
10 | elif [ "$1" = '--color=no' ]; then | |
11 | export MSGCOLOR='NO' | |
61e92778 DK |
12 | elif [ "$1" = '--color=yes' ]; then |
13 | export MSGCOLOR='YES' | |
14 | elif [ "$1" = '--color' ]; then | |
15 | export MSGCOLOR="$(echo "$2" | tr 'a-z' 'A-Z')" | |
16 | shift | |
17 | elif [ "$1" = '--level' ]; then | |
18 | export MSGLEVEL=$2 | |
19 | shift | |
68042532 DK |
20 | else |
21 | echo >&2 "WARNING: Unknown parameter »$1« will be ignored" | |
22 | fi | |
23 | shift | |
24 | done | |
25 | export MSGLEVEL="${MSGLEVEL:-3}" | |
26 | ||
8d876415 | 27 | # we all like colorful messages |
61e92778 | 28 | if [ "${MSGCOLOR:-YES}" = 'YES' ]; then |
27cb4f6c | 29 | if [ ! -t 1 ]; then # but check that we output to a terminal |
1290422a DK |
30 | export MSGCOLOR='NO' |
31 | fi | |
32 | fi | |
33 | ||
34 | ||
35 | if [ "$MSGCOLOR" != 'NO' ]; then | |
36 | CERROR="\033[1;31m" # red | |
37 | CWARNING="\033[1;33m" # yellow | |
38 | CMSG="\033[1;32m" # green | |
39 | CINFO="\033[1;96m" # light blue | |
40 | CDEBUG="\033[1;94m" # blue | |
41 | CNORMAL="\033[0;39m" # default system console color | |
42 | CDONE="\033[1;32m" # green | |
43 | CPASS="\033[1;32m" # green | |
44 | CFAIL="\033[1;31m" # red | |
45 | CCMD="\033[1;35m" # pink | |
682a3bf7 | 46 | fi |
8d876415 | 47 | |
de81b2e2 DK |
48 | msgprintf() { |
49 | local START="$1" | |
50 | local MIDDLE="$2" | |
51 | local END="$3" | |
52 | shift 3 | |
53 | if [ -n "$1" ]; then | |
54 | printf "$START " "$1" | |
d73840dc | 55 | shift |
de81b2e2 | 56 | while [ -n "$1" ]; do |
bc8f83a5 | 57 | printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghks]\)#apt-\1#')" |
de81b2e2 DK |
58 | shift |
59 | done | |
60 | fi | |
61 | printf "${END}" | |
2a2a7ef4 | 62 | } |
de81b2e2 DK |
63 | msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; } |
64 | msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; } | |
65 | msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; } | |
66 | msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; } | |
67 | msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; } | |
68 | msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; } | |
69 | msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; } | |
70 | msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; } | |
71 | msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; } | |
72 | msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; } | |
73 | msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; } | |
3c528b91 | 74 | msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; } |
1501a2c9 | 75 | msgreportheader() { |
68042532 | 76 | if [ -n "$MSGTEST_MSG" ]; then |
1501a2c9 | 77 | test "$1" != 'msgfailoutput' || echo |
ae7fce5a DK |
78 | if [ -n "$MSGTEST_MSGMSG" ]; then |
79 | echo "$MSGTEST_MSGMSG" | |
80 | fi | |
22ac12b2 | 81 | if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then |
1501a2c9 | 82 | echo "${CFAIL}Part of the test group: $MSGTEST_GRP" |
22ac12b2 | 83 | fi |
68042532 DK |
84 | echo -n "$MSGTEST_MSG" |
85 | unset MSGTEST_MSG | |
86 | fi | |
1501a2c9 DK |
87 | } |
88 | msgskip() { | |
89 | msgreportheader 'msgskip' | |
68ba0b7f DK |
90 | if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2; |
91 | else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi | |
92 | } | |
5229b285 | 93 | msgfail() { |
1501a2c9 | 94 | msgreportheader 'msgfail' |
68042532 | 95 | if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2; |
3c528b91 | 96 | else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi |
03aa0847 | 97 | if [ -n "$APT_DEBUG_TESTS" ]; then |
896f0ae8 | 98 | runapt $SHELL |
03aa0847 | 99 | fi |
5229b285 DK |
100 | EXIT_CODE=$((EXIT_CODE+1)); |
101 | } | |
9beb11aa DK |
102 | MSGGROUP_LEVEL=0 |
103 | msggroup() { | |
104 | if [ -n "$1" ]; then | |
105 | if [ $MSGGROUP_LEVEL = 0 ]; then | |
106 | MSGTEST_GRP='NEXT' | |
107 | fi | |
108 | MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1)); | |
109 | else | |
110 | MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1)); | |
111 | if [ $MSGGROUP_LEVEL = 0 ]; then | |
112 | unset MSGTEST_GRP | |
113 | fi | |
114 | fi | |
115 | } | |
8d876415 DK |
116 | |
117 | # enable / disable Debugging | |
fc89263e DK |
118 | if [ $MSGLEVEL -le 0 ]; then |
119 | msgdie() { true; } | |
120 | fi | |
121 | if [ $MSGLEVEL -le 1 ]; then | |
122 | msgwarn() { true; } | |
123 | msgnwarn() { true; } | |
124 | fi | |
125 | if [ $MSGLEVEL -le 2 ]; then | |
ae7fce5a DK |
126 | msgmsg() { |
127 | MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")" | |
128 | } | |
fc89263e | 129 | msgnmsg() { true; } |
9beb11aa DK |
130 | msgtest() { |
131 | MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")" | |
132 | if [ "$MSGTEST_GRP" = 'NEXT' ]; then | |
133 | MSGTEST_GRP="$MSGTEST_MSG" | |
134 | fi | |
135 | } | |
3c528b91 | 136 | msgpass() { printf " ${CPASS}P${CNORMAL}"; } |
fc89263e DK |
137 | fi |
138 | if [ $MSGLEVEL -le 3 ]; then | |
139 | msginfo() { true; } | |
140 | msgninfo() { true; } | |
141 | fi | |
142 | if [ $MSGLEVEL -le 4 ]; then | |
143 | msgdebug() { true; } | |
144 | msgndebug() { true; } | |
145 | fi | |
146 | msgdone() { | |
147 | if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] || | |
148 | [ "$1" = "info" -a $MSGLEVEL -le 3 ] || | |
149 | [ "$1" = "msg" -a $MSGLEVEL -le 2 ] || | |
150 | [ "$1" = "warn" -a $MSGLEVEL -le 1 ] || | |
151 | [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then | |
152 | true; | |
153 | else | |
3c528b91 | 154 | printf "${CDONE}DONE${CNORMAL}\n"; |
fc89263e DK |
155 | fi |
156 | } | |
e43a426e MV |
157 | getaptconfig() { |
158 | if [ -f ./aptconfig.conf ]; then | |
5465192b | 159 | echo "$(readlink -f ./aptconfig.conf)" |
e43a426e | 160 | elif [ -f ../aptconfig.conf ]; then |
5465192b DK |
161 | echo "$(readlink -f ../aptconfig.conf)" |
162 | elif [ -f ../../aptconfig.conf ]; then | |
163 | echo "$(readlink -f ../../aptconfig.conf)" | |
164 | elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then | |
165 | echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")" | |
166 | fi | |
e43a426e | 167 | } |
8d876415 DK |
168 | runapt() { |
169 | msgdebug "Executing: ${CCMD}$*${CDEBUG} " | |
846856f4 DK |
170 | local CMD="$1" |
171 | shift | |
3abb6a6a | 172 | case "$CMD" in |
a311fb96 | 173 | sh|aptitude|*/*|command) ;; |
3b8eb3bc DK |
174 | *) CMD="${BUILDDIRECTORY}/$CMD";; |
175 | esac | |
896f0ae8 | 176 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH="${LIBRARYPATH}:${LD_LIBRARY_PATH}" "$CMD" "$@" |
8d876415 | 177 | } |
0390edd5 | 178 | runpython3() { runapt command python3 "$@"; } |
846856f4 DK |
179 | aptconfig() { runapt apt-config "$@"; } |
180 | aptcache() { runapt apt-cache "$@"; } | |
181 | aptcdrom() { runapt apt-cdrom "$@"; } | |
182 | aptget() { runapt apt-get "$@"; } | |
dfd863ea | 183 | aptftparchive() { runapt "${APTFTPARCHIVEBINDIR}/apt-ftparchive" "$@"; } |
846856f4 DK |
184 | aptkey() { runapt apt-key "$@"; } |
185 | aptmark() { runapt apt-mark "$@"; } | |
4f6d26b4 | 186 | aptsortpkgs() { runapt apt-sortpkgs "$@"; } |
796673c3 | 187 | apt() { runapt apt "$@"; } |
3b8eb3bc DK |
188 | apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; } |
189 | aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; } | |
190 | aptitude() { runapt aptitude "$@"; } | |
8d50b63f | 191 | aptextracttemplates() { runapt apt-extracttemplates "$@"; } |
3082603f | 192 | aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; } |
ad7e0941 | 193 | aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; } |
8e99b22c | 194 | aptinternalplanner() { runapt "${APTINTERNALPLANNER}" "$@"; } |
3b8eb3bc | 195 | |
158fda31 | 196 | dpkg() { |
b0be0e09 | 197 | "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@" |
158fda31 | 198 | } |
ce7f128c | 199 | dpkgcheckbuilddeps() { |
63c71412 | 200 | command dpkg-checkbuilddeps --admindir="${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg" "$@" |
b6b5a542 | 201 | } |
3fa950f1 | 202 | gdb() { |
b07aeb1a DK |
203 | local CMD |
204 | case "$1" in | |
205 | aptget) CMD="apt-get";; | |
206 | aptcache) CMD="apt-cache";; | |
5465192b DK |
207 | aptcdrom) CMD="apt-cdrom";; |
208 | aptconfig) CMD="apt-config";; | |
b07aeb1a DK |
209 | aptmark) CMD="apt-mark";; |
210 | apthelper) CMD="apt-helper";; | |
3d8232bf | 211 | aptftparchive) CMD="apt-ftparchive";; |
63c71412 | 212 | dpkg) shift; runapt "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" "$@"; return;; |
b07aeb1a DK |
213 | *) CMD="$1";; |
214 | esac | |
ce928105 | 215 | shift |
921a9626 DK |
216 | if [ "${CMD##*/}" = "$CMD" ]; then |
217 | CMD="${BUILDDIRECTORY}/${CMD}" | |
218 | fi | |
f036d9bb | 219 | runapt command gdb --quiet -ex "directory '$SOURCEDIRECTORY'" -ex run "$CMD" --args "$CMD" "$@" |
ae99ce2e | 220 | } |
0340069c | 221 | lastmodification() { |
0b45b6e5 | 222 | date -u -d "@$(stat -c '%Y' "${TMPWORKINGDIRECTORY}/$1")" -R |
0340069c DK |
223 | } |
224 | releasefiledate() { | |
0b45b6e5 | 225 | grep "^${2:-Date}:" "$1" | cut -d' ' -f 2- |
0340069c | 226 | } |
8d876415 | 227 | |
8c1dd12c | 228 | exitwithstatus() { |
f91bd741 MV |
229 | # error if we about to overflow, but ... |
230 | # "255 failures ought to be enough for everybody" | |
5d76cee1 MV |
231 | if [ $EXIT_CODE -gt 255 ]; then |
232 | msgdie "Total failure count $EXIT_CODE too big" | |
f91bd741 | 233 | fi |
5d76cee1 | 234 | exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255)); |
8c1dd12c MV |
235 | } |
236 | ||
804d4a0d DK |
237 | shellsetedetector() { |
238 | local exit_status=$? | |
239 | if [ "$exit_status" != '0' ]; then | |
3c528b91 | 240 | printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n" |
804d4a0d DK |
241 | if [ "$EXIT_CODE" = '0' ]; then |
242 | EXIT_CODE="$exit_status" | |
243 | fi | |
244 | fi | |
245 | } | |
246 | ||
b720d0bd | 247 | addtrap() { |
8437b7d4 DK |
248 | if [ "$1" = 'prefix' ]; then |
249 | CURRENTTRAP="$2 $CURRENTTRAP" | |
250 | else | |
251 | CURRENTTRAP="$CURRENTTRAP $1" | |
252 | fi | |
804d4a0d | 253 | trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM |
b720d0bd | 254 | } |
8d876415 | 255 | |
bc8f83a5 DK |
256 | escape_shell() { |
257 | echo "$@" | sed -e "s#'#'\"'\"'#g" | |
258 | } | |
259 | ||
61fef4dd JAK |
260 | find_project_binary_dir() { |
261 | local TESTDIRECTORY="$(readlink -f "$(dirname $0)")" | |
262 | if [ -z "$PROJECT_BINARY_DIR" ]; then | |
263 | PROJECT_BINARY_DIR= | |
264 | for dir in ${TESTDIRECTORY}/../../ ${TESTDIRECTORY}/../../*; do | |
265 | test -e "$dir/CMakeCache.txt" || continue | |
266 | if [ -z "$PROJECT_BINARY_DIR" ] || | |
267 | [ "$dir/CMakeCache.txt" -nt "$PROJECT_BINARY_DIR/CMakeCache.txt" ]; then | |
268 | PROJECT_BINARY_DIR="$dir" | |
269 | fi | |
270 | done | |
271 | if [ -z "$PROJECT_BINARY_DIR" ]; then | |
272 | echo "Cannot find build directory, you might want to set PROJECT_BINARY_DIR" >&2 | |
273 | exit 1 | |
274 | fi | |
275 | export PROJECT_BINARY_DIR | |
276 | fi | |
277 | } | |
8d876415 | 278 | setupenvironment() { |
0d303f17 DK |
279 | # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir) |
280 | if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then | |
281 | unset TMPDIR | |
282 | fi | |
63c71412 | 283 | TMPWORKINGDIRECTORY="$(mktemp -d)" |
bc8f83a5 DK |
284 | addtrap "cd /; rm -rf '$(escape_shell "$TMPWORKINGDIRECTORY")';" |
285 | if [ -n "$TMPDIR_ADD" ]; then | |
286 | TMPWORKINGDIRECTORY="${TMPWORKINGDIRECTORY}/${TMPDIR_ADD}" | |
287 | mkdir -p "$TMPWORKINGDIRECTORY" | |
288 | unset TMPDIR_ADD | |
289 | export TMPDIR="$TMPWORKINGDIRECTORY" | |
290 | fi | |
63c71412 | 291 | msgninfo "Preparing environment for ${0##*/} in ${TMPWORKINGDIRECTORY}…" |
5c0dd6fc | 292 | |
03aa0847 | 293 | mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded" |
68ba0b7f DK |
294 | if [ "$(id -u)" = '0' ]; then |
295 | # relax permissions so that running as root with user switching works | |
296 | umask 022 | |
03aa0847 DK |
297 | chmod 711 "$TMPWORKINGDIRECTORY" |
298 | chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded" | |
68ba0b7f DK |
299 | fi |
300 | ||
63c71412 | 301 | TESTDIRECTORY="$(readlink -f "$(dirname $0)")" |
61fef4dd JAK |
302 | # Find the newest build directory (sets PROJECT_BINARY_DIR) |
303 | find_project_binary_dir | |
5c0dd6fc | 304 | # allow overriding the default BUILDDIR location |
63c71412 | 305 | SOURCEDIRECTORY="${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}" |
61fef4dd | 306 | BUILDDIRECTORY="${APT_INTEGRATION_TESTS_BUILD_DIR:-"${PROJECT_BINARY_DIR}/cmdline"}" |
dfd863ea JAK |
307 | LIBRARYPATH="${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}/../apt-pkg"}" |
308 | METHODSDIR="${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/../methods"}" | |
63c71412 | 309 | APTHELPERBINDIR="${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}" |
dfd863ea JAK |
310 | APTWEBSERVERBINDIR="${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}/../test/interactive-helper"}" |
311 | APTFTPARCHIVEBINDIR="${APT_INTEGRATION_TESTS_FTPARCHIVE_BIN_DIR:-"${BUILDDIRECTORY}/../ftparchive"}" | |
312 | APTINTERNALSOLVER="${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/solvers/apt"}" | |
313 | APTDUMPSOLVER="${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/solvers/dump"}" | |
314 | APTINTERNALPLANNER="${APT_INTEGRATION_TESTS_INTERNAL_PLANNER:-"${BUILDDIRECTORY}/planners/apt"}" | |
8d876415 | 315 | test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first" |
5c0dd6fc MV |
316 | # ----- |
317 | ||
63c71412 | 318 | cd "$TMPWORKINGDIRECTORY" |
cd725954 | 319 | mkdir rootdir aptarchive keys |
8d876415 | 320 | cd rootdir |
b29c3712 | 321 | mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d |
84255101 | 322 | mkdir -p usr/bin var/cache var/lib var/log var/crash tmp |
cffea9af | 323 | mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers |
b327c569 | 324 | mkdir -p usr/lib/apt/solvers usr/lib/apt/planners |
cd725954 | 325 | touch var/lib/dpkg/available |
63c71412 | 326 | ln -s "${METHODSDIR}" usr/lib/apt/methods |
b327c569 DK |
327 | ln -s "${APTDUMPSOLVER}" usr/lib/apt/solvers/dump |
328 | ln -s "${APTDUMPSOLVER}" usr/lib/apt/planners/dump | |
329 | ln -s "${APTINTERNALSOLVER}" usr/lib/apt/solvers/apt | |
330 | ln -s "${APTINTERNALPLANNER}" usr/lib/apt/planners/apt | |
331 | echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" >> ../aptconfig.conf | |
332 | echo "Dir::Bin::Planners \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/planners\";" >> ../aptconfig.conf | |
291a386f MV |
333 | # use the autoremove from the BUILDDIRECTORY if its there, otherwise |
334 | # system | |
c21dab68 DK |
335 | if [ -z "${APT_INTEGRATION_TESTS_SOURCE_DIR}" ]; then |
336 | ln -s "${SOURCEDIRECTORY}/debian/apt.conf.autoremove" etc/apt/apt.conf.d/01autoremove | |
291a386f MV |
337 | else |
338 | ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove | |
339 | fi | |
8d876415 | 340 | cd .. |
63c71412 DK |
341 | local BASENAME="${0##*/}" |
342 | local PACKAGESFILE="Packages-${BASENAME#*-}" | |
53ea1b56 DK |
343 | if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then |
344 | cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages | |
8f8169ac | 345 | fi |
63c71412 | 346 | local SOURCESSFILE="Sources-${BASENAME#*-}" |
53ea1b56 DK |
347 | if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then |
348 | cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources | |
8f8169ac | 349 | fi |
3abb6a6a DK |
350 | find "$TESTDIRECTORY" \( -name '*.pub' -o -name '*.sec' \) -exec cp '{}' keys/ \; |
351 | chmod 644 keys/* | |
63c71412 | 352 | ln -s "${TMPWORKINGDIRECTORY}/keys/joesixpack.pub" rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg |
d6cf2345 | 353 | |
b4f91d4d | 354 | echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf |
8d876415 | 355 | echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf |
9d2a8a73 | 356 | echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf |
23e64f6d DK |
357 | # either store apt-key were we can access it, even if we run it as a different user |
358 | #cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/" | |
359 | #chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key" | |
360 | #echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf | |
361 | # destroys coverage reporting though, so we disable changing user for the calling gpgv | |
362 | echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf | |
68ba0b7f | 363 | if [ "$(id -u)" = '0' ]; then |
007d8b48 DK |
364 | echo 'Binary::gpgv::APT::Sandbox::User "root";' >> aptconfig.conf |
365 | # same for the solver executables | |
366 | echo 'APT::Solver::RunAsUser "root";' >> aptconfig.conf | |
8e99b22c | 367 | echo 'APT::Planner::RunAsUser "root";' >> aptconfig.conf |
68ba0b7f | 368 | fi |
b0be0e09 | 369 | |
63c71412 | 370 | cat > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF |
b0be0e09 DK |
371 | #!/bin/sh |
372 | set -e | |
3abb6a6a | 373 | if [ -r '${TMPWORKINGDIRECTORY}/noopchroot.so' ]; then |
63c71412 | 374 | if [ -n "\$LD_LIBRARY_PATH" ]; then |
3abb6a6a | 375 | export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}:'"\${LD_LIBRARY_PATH}" |
b0be0e09 | 376 | else |
3abb6a6a | 377 | export LD_LIBRARY_PATH='${TMPWORKINGDIRECTORY}' |
b0be0e09 | 378 | fi |
921a9626 | 379 | if [ -n "\$LD_PRELOAD" ]; then |
63c71412 | 380 | export LD_PRELOAD="noopchroot.so \${LD_PRELOAD}" |
921a9626 | 381 | else |
63c71412 | 382 | export LD_PRELOAD="noopchroot.so" |
921a9626 DK |
383 | fi |
384 | fi | |
63c71412 DK |
385 | EOF |
386 | cp "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" | |
387 | cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" <<EOF | |
3abb6a6a DK |
388 | exec fakeroot '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\ |
389 | --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\ | |
63c71412 DK |
390 | --force-not-root --force-bad-path "\$@" |
391 | EOF | |
392 | cat >> "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" <<EOF | |
3abb6a6a DK |
393 | exec fakeroot gdb --quiet -ex run '${DPKG:-dpkg}' --args '${DPKG:-dpkg}' --root='${TMPWORKINGDIRECTORY}/rootdir' \\ |
394 | --log='${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log' \\ | |
b0be0e09 DK |
395 | --force-not-root --force-bad-path "\$@" |
396 | EOF | |
921a9626 | 397 | chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg" |
b0be0e09 DK |
398 | echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg |
399 | ||
533fe3d1 DK |
400 | { |
401 | if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then | |
402 | echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it… | |
403 | fi | |
87d6947d | 404 | echo 'quiet "0";' |
533fe3d1 DK |
405 | echo 'quiet::NoUpdate "true";' |
406 | echo 'quiet::NoStatistic "true";' | |
407 | # too distracting for users, but helpful to detect changes | |
408 | echo 'Acquire::Progress::Ignore::ShowErrorText "true";' | |
409 | echo 'Acquire::Progress::Diffpercent "true";' | |
410 | # in testcases, it can appear as if localhost has a rotation setup, | |
411 | # hide this as we can't really deal with it properly | |
412 | echo 'Acquire::Failure::ShowIP "false";' | |
ebca2f25 DK |
413 | # fakeroot can't fake everything, so disabled in production but good for tests |
414 | echo 'APT::Sandbox::Verify "true";' | |
533fe3d1 | 415 | } >> aptconfig.conf |
d6cf2345 | 416 | |
68ba0b7f DK |
417 | cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem" |
418 | if [ "$(id -u)" = '0' ]; then | |
419 | chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem" | |
420 | fi | |
421 | echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https | |
d6cf2345 | 422 | echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary |
08fcf962 | 423 | export APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=no |
23d35ec1 | 424 | echo 'Acquire::Connect::AddrConfig "false";' > rootdir/etc/apt/apt.conf.d/connect-addrconfig |
493a813e | 425 | |
276e51dd | 426 | configcompression '.' 'gz' #'bz2' 'lzma' 'xz' |
51c04562 | 427 | confighashes 'SHA256' # these are tests, not security best-practices |
77a45beb | 428 | |
4bb006d1 | 429 | # create some files in /tmp and look at user/group to get what this means |
eab57e08 | 430 | TEST_DEFAULT_USER="$(id -un)" |
4bb006d1 DK |
431 | if [ "$(uname)" = 'GNU/kFreeBSD' ]; then |
432 | TEST_DEFAULT_GROUP='root' | |
433 | else | |
eab57e08 | 434 | TEST_DEFAULT_GROUP="$(id -gn)" |
4bb006d1 DK |
435 | fi |
436 | ||
ce7f128c | 437 | # cleanup the environment a bit |
995a4bf6 | 438 | # prefer our apt binaries over the system apt binaries |
8c617819 | 439 | export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin" |
be233796 | 440 | export LC_ALL=C.UTF-8 |
3b8eb3bc | 441 | unset LANGUAGE APT_CONFIG |
ce7f128c | 442 | unset GREP_OPTIONS DEB_BUILD_PROFILES |
59f57473 | 443 | unset http_proxy HTTP_PROXY https_proxy HTTPS_PROXY no_proxy |
0cbb7e29 JAK |
444 | |
445 | # If gpgv supports --weak-digest, pass it to make sure we can disable SHA1 | |
446 | if aptkey verify --weak-digest SHA1 --help 2>/dev/null >/dev/null; then | |
447 | echo 'Acquire::gpgv::Options { "--weak-digest"; "sha1"; };' > rootdir/etc/apt/apt.conf.d/no-sha1 | |
448 | fi | |
449 | ||
5a23c56d DK |
450 | # most tests just need one signed Release file, not both |
451 | export APT_DONT_SIGN='Release.gpg' | |
452 | ||
60b48d4f DK |
453 | if [ -r "${TESTDIRECTORY}/extra-environment" ]; then |
454 | . "${TESTDIRECTORY}/extra-environment" | |
455 | fi | |
456 | ||
8d876415 DK |
457 | msgdone "info" |
458 | } | |
459 | ||
ea65d079 DK |
460 | getarchitecture() { |
461 | if [ "$1" = "native" -o -z "$1" ]; then | |
462 | eval `aptconfig shell ARCH APT::Architecture` | |
463 | if [ -n "$ARCH" ]; then | |
464 | echo $ARCH | |
465 | else | |
5834d7a1 | 466 | dpkg --print-architecture |
ea65d079 DK |
467 | fi |
468 | else | |
469 | echo $1 | |
470 | fi | |
471 | } | |
472 | ||
53ea1b56 | 473 | getarchitectures() { |
081c9d44 | 474 | aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' ' |
53ea1b56 DK |
475 | } |
476 | ||
3dcdc1f9 DK |
477 | getarchitecturesfromcommalist() { |
478 | echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/" | |
479 | } | |
480 | ||
8d876415 | 481 | configarchitecture() { |
18908589 DK |
482 | { |
483 | echo "APT::Architecture \"$(getarchitecture $1)\";" | |
484 | while [ -n "$1" ]; do | |
485 | echo "APT::Architectures:: \"$(getarchitecture $1)\";" | |
486 | shift | |
487 | done | |
488 | } >rootdir/etc/apt/apt.conf.d/01multiarch.conf | |
53ea1b56 DK |
489 | configdpkg |
490 | } | |
491 | ||
492 | configdpkg() { | |
493 | if [ ! -e rootdir/var/lib/dpkg/status ]; then | |
63c71412 DK |
494 | local BASENAME="${0##*/}" |
495 | local STATUSFILE="status-${BASENAME#*-}" | |
53ea1b56 DK |
496 | if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then |
497 | cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status | |
498 | else | |
499 | echo -n > rootdir/var/lib/dpkg/status | |
500 | fi | |
501 | fi | |
18908589 | 502 | rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg |
846856f4 | 503 | if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then |
53ea1b56 | 504 | local ARCHS="$(getarchitectures)" |
87f99f6f DK |
505 | local DPKGARCH="$(dpkg --print-architecture)" |
506 | # this ensures that even if multi-arch isn't active in the view | |
507 | # of apt, given that dpkg can't be told which arch is native | |
508 | # the arch apt treats as native might be foreign for dpkg | |
509 | for ARCH in ${ARCHS}; do | |
510 | if [ "${ARCH}" != "${DPKGARCH}" ]; then | |
511 | if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then | |
512 | # old-style used e.g. in Ubuntu-P – and as it seems travis | |
513 | echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
514 | echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
feae193b | 515 | fi |
87f99f6f DK |
516 | fi |
517 | done | |
518 | # if multi-arch make sure dpkg can detect itself as capable of it | |
519 | if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then | |
53ea1b56 | 520 | if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then |
05343a22 DK |
521 | # dpkg doesn't really check the version as long as it is fully installed, |
522 | # but just to be sure we choose one above the required version | |
523 | insertinstalledpackage 'dpkg' "all" '1.16.2+fake' | |
53ea1b56 DK |
524 | fi |
525 | fi | |
526 | fi | |
8d876415 DK |
527 | } |
528 | ||
0c787570 DK |
529 | configdpkgnoopchroot() { |
530 | # create a library to noop chroot() and rewrite maintainer script executions | |
531 | # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown | |
532 | # chroot directory dpkg could chroot into to execute the maintainer scripts | |
533 | msgtest 'Building library to preload to make maintainerscript work in' 'dpkg' | |
63c71412 | 534 | cat > noopchroot.c << EOF |
0c787570 DK |
535 | #define _GNU_SOURCE |
536 | #include <stdio.h> | |
537 | #include <stdlib.h> | |
538 | #include <string.h> | |
539 | #include <dlfcn.h> | |
540 | ||
541 | static char * chrootdir = NULL; | |
542 | ||
543 | int chroot(const char *path) { | |
544 | printf("WARNING: CHROOTing to %s was ignored!\n", path); | |
545 | free(chrootdir); | |
546 | chrootdir = strdup(path); | |
547 | return 0; | |
548 | } | |
549 | int execvp(const char *file, char *const argv[]) { | |
550 | static int (*func_execvp) (const char *, char * const []) = NULL; | |
551 | if (func_execvp == NULL) | |
552 | func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp"); | |
553 | if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0) | |
554 | return func_execvp(file, argv); | |
555 | printf("REWRITE execvp call %s into %s\n", file, chrootdir); | |
950733c9 JAK |
556 | char *newfile; |
557 | if (asprintf(&newfile, "%s%s", chrootdir, file) == -1) { | |
558 | perror("asprintf"); | |
559 | return -1; | |
560 | } | |
b0be0e09 | 561 | char const * const baseadmindir = "/var/lib/dpkg"; |
950733c9 JAK |
562 | char *admindir; |
563 | if (asprintf(&admindir, "%s%s", chrootdir, baseadmindir) == -1) { | |
564 | perror("asprintf"); | |
565 | return -1; | |
566 | } | |
b0be0e09 | 567 | setenv("DPKG_ADMINDIR", admindir, 1); |
0c787570 DK |
568 | return func_execvp(newfile, argv); |
569 | } | |
570 | EOF | |
a66e1837 | 571 | testempty --nomsg gcc -Wall -Wextra -fPIC -shared -o noopchroot.so noopchroot.c -ldl |
0c787570 | 572 | } |
276e51dd | 573 | configcompression() { |
bdc42211 DK |
574 | if [ "$1" = 'ALL' ]; then |
575 | configcompression '.' $(aptconfig dump APT::Compressor --format '%t %v%n' | sed -n 's#^Extension \.\(.*\)$#\1#p') | |
576 | return | |
577 | fi | |
abec2980 | 578 | local CMD='apthelper cat-file -C' |
276e51dd DK |
579 | while [ -n "$1" ]; do |
580 | case "$1" in | |
3c528b91 | 581 | '.') printf ".\t.\tcat\n";; |
abec2980 DK |
582 | 'gz') printf "gzip\tgz\t$CMD $1\n";; |
583 | 'bz2') printf "bzip2\tbz2\t$CMD $1\n";; | |
584 | *) printf "$1\t$1\t$CMD $1\n";; | |
276e51dd DK |
585 | esac |
586 | shift | |
63c71412 | 587 | done > "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" |
276e51dd | 588 | } |
c5ede4ca DK |
589 | confighashes() { |
590 | { | |
591 | echo 'APT::FTPArchive {' | |
592 | { | |
593 | while [ -n "$1" ]; do | |
594 | printf "$1" | tr 'a-z' 'A-Z' | |
595 | printf "\t\"true\";\n" | |
596 | shift | |
597 | done | |
598 | for h in 'MD5' 'SHA1' 'SHA256' 'SHA512'; do | |
599 | printf "$h\t\"false\";\n" | |
600 | done | |
601 | } | awk '!x[$1]++' | |
602 | echo '};' | |
603 | } >> "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/ftparchive-hashes.conf" | |
604 | } | |
5f982b9d DK |
605 | forcecompressor() { |
606 | COMPRESSOR="$1" | |
912a6131 | 607 | COMPRESS="$1" |
abec2980 | 608 | COMPRESSOR_CMD="apthelper cat-file -C $1" |
5f982b9d DK |
609 | case $COMPRESSOR in |
610 | gzip) COMPRESS='gz';; | |
611 | bzip2) COMPRESS='bz2';; | |
5f982b9d DK |
612 | esac |
613 | local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor" | |
614 | echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; }; | |
912a6131 | 615 | Dir::Bin::uncompressed \"/does/not/exist\";" > "$CONFFILE" |
b2fd8524 DK |
616 | for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do |
617 | if [ -z "$COMP" -o "$COMP" = '.' -o "$COMP" = "$COMPRESSOR" ]; then continue; fi | |
618 | echo "Dir::Bin::${COMP} \"/does/not/exist\";" >> "$CONFFILE" | |
619 | echo "APT::Compressor::${COMP}::Name \"${COMP}-disabled\";" >> "$CONFFILE" | |
620 | done | |
5f982b9d DK |
621 | } |
622 | ||
b8242321 | 623 | _setupsimplenativepackage() { |
75954ae2 DK |
624 | local NAME="$1" |
625 | local ARCH="$2" | |
626 | local VERSION="$3" | |
627 | local RELEASE="${4:-unstable}" | |
628 | local DEPENDENCIES="$5" | |
14109555 | 629 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} |
18908589 DK |
630 | If you find such a package installed on your system, |
631 | something went horribly wrong! They are autogenerated | |
3d284148 | 632 | und used only by testcases and serve no other purpose…"}" |
18908589 | 633 | |
75954ae2 | 634 | local SECTION="${7:-others}" |
d67004e0 | 635 | local PRIORITY="${8:-optional}" |
63c71412 DK |
636 | local FILE_TREE="$9" |
637 | local COMPRESS_TYPE="${10:-gzip}" | |
75954ae2 | 638 | local DISTSECTION |
63c71412 | 639 | if [ "$SECTION" = "${SECTION#*/}" ]; then |
75954ae2 DK |
640 | DISTSECTION="main" |
641 | else | |
63c71412 | 642 | DISTSECTION="${SECTION%/*}" |
75954ae2 | 643 | fi |
63c71412 | 644 | local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}" |
b761356f | 645 | |
63c71412 DK |
646 | mkdir -p "$BUILDDIR/debian/source" |
647 | echo "* most suckless software product ever" > "${BUILDDIR}/FEATURES" | |
b761356f | 648 | echo "#!/bin/sh |
63c71412 | 649 | echo '$NAME says \"Hello!\"'" > "${BUILDDIR}/${NAME}" |
b761356f | 650 | |
0340069c | 651 | echo "Copyleft by Joe Sixpack $(date -u +%Y)" > "${BUILDDIR}/debian/copyright" |
b761356f DK |
652 | echo "$NAME ($VERSION) $RELEASE; urgency=low |
653 | ||
654 | * Initial release | |
655 | ||
0340069c | 656 | -- Joe Sixpack <joe@example.org> $(date -u -R)" > "${BUILDDIR}/debian/changelog" |
63c71412 DK |
657 | { |
658 | echo "Source: $NAME | |
d67004e0 | 659 | Priority: $PRIORITY |
b761356f | 660 | Maintainer: Joe Sixpack <joe@example.org> |
63c71412 DK |
661 | Standards-Version: 3.9.3" |
662 | if [ "$SECTION" != '<none>' ]; then | |
663 | echo "Section: $SECTION" | |
664 | fi | |
665 | local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')" | |
666 | test -z "$BUILDDEPS" || echo "$BUILDDEPS" | |
667 | echo " | |
668 | Package: $NAME" | |
b761356f | 669 | |
63c71412 DK |
670 | if [ "$ARCH" = 'all' ]; then |
671 | echo "Architecture: all" | |
672 | else | |
673 | echo "Architecture: any" | |
674 | fi | |
675 | local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')" | |
676 | test -z "$DEPS" || echo "$DEPS" | |
677 | echo "Description: $DESCRIPTION" | |
678 | } > "${BUILDDIR}/debian/control" | |
01f520ce | 679 | |
63c71412 | 680 | echo '3.0 (native)' > "${BUILDDIR}/debian/source/format" |
b8242321 DK |
681 | } |
682 | ||
683 | setupsimplenativepackage() { | |
684 | _setupsimplenativepackage "$@" | |
685 | local NAME="$1" | |
686 | local VERSION="$3" | |
687 | local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}" | |
688 | test -e "${BUILDDIR}/debian/compat" || echo '7' > "${BUILDDIR}/debian/compat" | |
689 | test -e "${BUILDDIR}/debian/rules" || cp /usr/share/doc/debhelper/examples/rules.tiny "${BUILDDIR}/debian/rules" | |
690 | } | |
691 | ||
692 | buildsimplenativepackage() { | |
693 | local NAME="$1" | |
694 | local ARCH="$2" | |
695 | local VERSION="$3" | |
696 | local RELEASE="${4:-unstable}" | |
697 | local DEPENDENCIES="$5" | |
698 | local DESCRIPTION="$6" | |
699 | local SECTION="${7:-others}" | |
700 | local PRIORITY="${8:-optional}" | |
701 | local FILE_TREE="$9" | |
702 | local COMPRESS_TYPE="${10:-gzip}" | |
703 | local DISTSECTION | |
704 | if [ "$SECTION" = "${SECTION#*/}" ]; then | |
705 | DISTSECTION="main" | |
706 | else | |
707 | DISTSECTION="${SECTION%/*}" | |
708 | fi | |
709 | local BUILDDIR="${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}" | |
710 | msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME" | |
711 | _setupsimplenativepackage "$@" | |
63c71412 | 712 | cd "${BUILDDIR}/.." |
0c787570 DK |
713 | testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION} |
714 | cd - >/dev/null | |
63c71412 | 715 | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" \ |
f1828b69 | 716 | | while read SRC; do |
63c71412 | 717 | echo "pool/${SRC}" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist" |
f1828b69 | 718 | # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then |
33a22672 | 719 | # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \ |
bd7fb5aa | 720 | # adv --yes --default-key 'Joe Sixpack' \ |
f1828b69 DK |
721 | # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" |
722 | # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
723 | # fi | |
b761356f | 724 | done |
84aa13f4 | 725 | |
3dcdc1f9 | 726 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do |
0c787570 | 727 | msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME" |
63c71412 DK |
728 | rm -rf "${BUILDDIR}/debian/tmp" |
729 | mkdir -p "${BUILDDIR}/debian/tmp/DEBIAN" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin" | |
730 | cp "${BUILDDIR}/debian/copyright" "${BUILDDIR}/debian/changelog" "${BUILDDIR}/FEATURES" "${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}" | |
731 | cp "${BUILDDIR}/${NAME}" "${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}" | |
42c1513b | 732 | if [ -n "$FILE_TREE" ]; then |
63c71412 | 733 | cp -ar "$FILE_TREE" "${BUILDDIR}/debian/tmp" |
42c1513b | 734 | fi |
42c1513b | 735 | |
63c71412 DK |
736 | (cd "${BUILDDIR}"; dpkg-gencontrol -DArchitecture=$arch) |
737 | (cd "${BUILDDIR}/debian/tmp"; md5sum $(find usr/ -type f) > DEBIAN/md5sums) | |
846856f4 | 738 | local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log" |
d56e2917 | 739 | # ensure the right permissions as dpkg-deb insists |
63c71412 DK |
740 | chmod 755 "${BUILDDIR}/debian/tmp/DEBIAN" |
741 | testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build "${BUILDDIR}/debian/tmp" "${BUILDDIR}/.." | |
742 | echo "pool/${NAME}_${VERSION}_${arch}.deb" >> "${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist" | |
84aa13f4 DK |
743 | done |
744 | ||
b8242321 DK |
745 | local NM |
746 | if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then | |
747 | NM="$(echo "$NAME" | cut -c 1-4)" | |
748 | else | |
749 | NM="$(echo "$NAME" | cut -c 1)" | |
750 | fi | |
d56e2917 | 751 | local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}" |
63c71412 DK |
752 | mkdir -p "$CHANGEPATH" |
753 | cp "${BUILDDIR}/debian/changelog" "$CHANGEPATH" | |
5a635ee4 | 754 | rm -rf "${BUILDDIR}" |
b761356f | 755 | msgdone "info" |
75954ae2 DK |
756 | } |
757 | ||
758 | buildpackage() { | |
759 | local BUILDDIR=$1 | |
760 | local RELEASE=$2 | |
761 | local SECTION=$3 | |
ea65d079 | 762 | local ARCH=$(getarchitecture $4) |
846856f4 DK |
763 | local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')" |
764 | local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")" | |
0c787570 | 765 | msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME" |
63c71412 | 766 | cd "$BUILDDIR" |
75954ae2 DK |
767 | if [ "$ARCH" = "all" ]; then |
768 | ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)" | |
769 | fi | |
0c787570 | 770 | testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH |
63c71412 DK |
771 | cp "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$BUILDLOG" |
772 | local PKGS="$(grep '^dpkg-deb: building package' "$BUILDLOG" | cut -d'/' -f 2 | sed -e "s#'\.##")" | |
773 | local SRCS="$(grep '^dpkg-source: info: building' "$BUILDLOG" | grep -o '[a-z0-9._+~-]*$')" | |
ce9864a8 | 774 | cd - > /dev/null |
b7899b00 | 775 | for PKG in $PKGS; do |
63c71412 | 776 | echo "pool/${PKG}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist" |
b7899b00 DK |
777 | done |
778 | for SRC in $SRCS; do | |
63c71412 | 779 | echo "pool/${SRC}" >> "${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist" |
b7899b00 | 780 | done |
ce9864a8 DK |
781 | } |
782 | ||
783 | buildaptarchive() { | |
ce9864a8 | 784 | if [ -d incoming ]; then |
846856f4 | 785 | buildaptarchivefromincoming "$@" |
ce9864a8 | 786 | else |
846856f4 | 787 | buildaptarchivefromfiles "$@" |
ce9864a8 DK |
788 | fi |
789 | } | |
790 | ||
791 | createaptftparchiveconfig() { | |
63c71412 | 792 | local COMPRESSORS="$(cut -d' ' -f 1 "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" | tr '\n' ' ')" |
016bea82 DK |
793 | local COMPRESSORS="${COMPRESSORS%* }" |
794 | local ARCHS="$(getarchitectures)" | |
c5ede4ca DK |
795 | cat > ftparchive.conf <<EOF |
796 | Dir { | |
797 | ArchiveDir "$(readlink -f .)"; | |
798 | CacheDir "$(readlink -f ..)"; | |
799 | FileListDir "$(readlink -f pool/)"; | |
b7899b00 DK |
800 | }; |
801 | Default { | |
c5ede4ca DK |
802 | Packages::Compress "$COMPRESSORS"; |
803 | Sources::Compress "$COMPRESSORS"; | |
804 | Contents::Compress "$COMPRESSORS"; | |
805 | Translation::Compress "$COMPRESSORS"; | |
18331adf | 806 | LongDescription "false"; |
ce9864a8 DK |
807 | }; |
808 | TreeDefault { | |
809 | Directory "pool/"; | |
810 | SrcDirectory "pool/"; | |
811 | }; | |
c5ede4ca | 812 | EOF |
b7899b00 | 813 | for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do |
63c71412 DK |
814 | cat <<EOF |
815 | tree "dists/$DIST" { | |
1dd20368 | 816 | Architectures "$ARCHS all source"; |
63c71412 DK |
817 | FileList "${DIST}.\$(SECTION).pkglist"; |
818 | SourceFileList "${DIST}.\$(SECTION).srclist"; | |
819 | Sections "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')"; | |
820 | }; | |
821 | EOF | |
822 | done >> ftparchive.conf | |
ce9864a8 DK |
823 | } |
824 | ||
825 | buildaptftparchivedirectorystructure() { | |
b7899b00 DK |
826 | local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')" |
827 | for DIST in $DISTS; do | |
828 | local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)" | |
829 | for SECTION in $SECTIONS; do | |
830 | local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')" | |
831 | for ARCH in $ARCHS; do | |
63c71412 | 832 | mkdir -p "dists/${DIST}/${SECTION}/binary-${ARCH}" |
b7899b00 | 833 | done |
63c71412 DK |
834 | mkdir -p "dists/${DIST}/${SECTION}/source" |
835 | mkdir -p "dists/${DIST}/${SECTION}/i18n" | |
b7899b00 | 836 | done |
ce9864a8 | 837 | done |
ce9864a8 DK |
838 | } |
839 | ||
9b78cda6 | 840 | insertpackage() { |
10e100e5 | 841 | local RELEASES="$1" |
9b78cda6 DK |
842 | local NAME="$2" |
843 | local ARCH="$3" | |
844 | local VERSION="$4" | |
845 | local DEPENDENCIES="$5" | |
d67004e0 | 846 | local PRIORITY="${6:-optional}" |
10e100e5 | 847 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES} |
18908589 DK |
848 | If you find such a package installed on your system, |
849 | something went horribly wrong! They are autogenerated | |
3d284148 | 850 | und used only by testcases and serve no other purpose…"}" |
d67004e0 | 851 | local ARCHS="" |
10e100e5 DK |
852 | for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do |
853 | if [ "$RELEASE" = 'installed' ]; then | |
854 | insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7" | |
855 | continue | |
d67004e0 | 856 | fi |
10e100e5 | 857 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do |
1dd20368 | 858 | if [ "$arch" = 'none' ]; then |
10e100e5 DK |
859 | ARCHS="$(getarchitectures)" |
860 | else | |
861 | ARCHS="$arch" | |
862 | fi | |
863 | for BUILDARCH in $ARCHS; do | |
864 | local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}" | |
63c71412 DK |
865 | mkdir -p "$PPATH" |
866 | { | |
867 | echo "Package: $NAME | |
d67004e0 | 868 | Priority: $PRIORITY |
9b78cda6 | 869 | Section: other |
2c085486 | 870 | Installed-Size: 42 |
63c71412 DK |
871 | Maintainer: Joe Sixpack <joe@example.org>" |
872 | test "$arch" = 'none' || echo "Architecture: $arch" | |
873 | echo "Version: $VERSION | |
874 | Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" | |
875 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" | |
876 | echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" | |
877 | echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" | |
2e2865ae | 878 | echo "SHA256: 0000000000000000000000000000000000000000000000000000000000000000" |
63c71412 DK |
879 | echo |
880 | } >> "${PPATH}/Packages" | |
10e100e5 | 881 | done |
d67004e0 | 882 | done |
63c71412 DK |
883 | mkdir -p "aptarchive/dists/${RELEASE}/main/source" "aptarchive/dists/${RELEASE}/main/i18n" |
884 | touch "aptarchive/dists/${RELEASE}/main/source/Sources" | |
10e100e5 | 885 | echo "Package: $NAME |
0e0d9919 DK |
886 | Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1) |
887 | Description-en: $DESCRIPTION | |
63c71412 | 888 | " >> "aptarchive/dists/${RELEASE}/main/i18n/Translation-en" |
10e100e5 | 889 | done |
9b78cda6 DK |
890 | } |
891 | ||
234675b7 | 892 | insertsource() { |
07aca07a | 893 | local RELEASES="$1" |
234675b7 DK |
894 | local NAME="$2" |
895 | local ARCH="$3" | |
896 | local VERSION="$4" | |
897 | local DEPENDENCIES="$5" | |
07aca07a | 898 | local BINARY="${6:-$NAME}" |
234675b7 | 899 | local ARCHS="" |
07aca07a DK |
900 | for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do |
901 | local SPATH="aptarchive/dists/${RELEASE}/main/source" | |
902 | mkdir -p $SPATH | |
903 | local FILE="${SPATH}/Sources" | |
904 | local DSCFILE="${NAME}_${VERSION}.dsc" | |
905 | local TARFILE="${NAME}_${VERSION}.tar.gz" | |
906 | echo "Package: $NAME | |
a8275acf | 907 | Binary: $BINARY |
234675b7 DK |
908 | Version: $VERSION |
909 | Maintainer: Joe Sixpack <joe@example.org> | |
910 | Architecture: $ARCH" >> $FILE | |
07aca07a DK |
911 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE" |
912 | echo "Files: | |
63c71412 DK |
913 | $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE" |
914 | $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE" | |
55ae7a51 | 915 | Checksums-Sha256: |
63c71412 DK |
916 | $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) "$DSCFILE" |
917 | $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) "$TARFILE" | |
918 | " >> "$FILE" | |
07aca07a | 919 | done |
234675b7 DK |
920 | } |
921 | ||
dfc2b1be DK |
922 | insertinstalledpackage() { |
923 | local NAME="$1" | |
924 | local ARCH="$2" | |
925 | local VERSION="$3" | |
926 | local DEPENDENCIES="$4" | |
d67004e0 | 927 | local PRIORITY="${5:-optional}" |
d4b4e5ea | 928 | local STATUS="${6:-install ok installed}" |
14109555 | 929 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed |
18908589 DK |
930 | If you find such a package installed on your system, |
931 | something went horribly wrong! They are autogenerated | |
3d284148 | 932 | und used only by testcases and serve no other purpose…"}" |
18908589 | 933 | |
53ea1b56 DK |
934 | local FILE='rootdir/var/lib/dpkg/status' |
935 | local INFO='rootdir/var/lib/dpkg/info' | |
3dcdc1f9 | 936 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do |
d67004e0 | 937 | echo "Package: $NAME |
d4b4e5ea | 938 | Status: $STATUS |
d67004e0 | 939 | Priority: $PRIORITY |
dfc2b1be DK |
940 | Section: other |
941 | Installed-Size: 42 | |
942 | Maintainer: Joe Sixpack <joe@example.org> | |
63c71412 DK |
943 | Version: $VERSION" >> "$FILE" |
944 | test "$arch" = 'none' || echo "Architecture: $arch" >> "$FILE" | |
945 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> "$FILE" | |
946 | echo "Description: $DESCRIPTION" >> "$FILE" | |
947 | echo >> "$FILE" | |
53ea1b56 | 948 | if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then |
63c71412 | 949 | echo -n > "${INFO}/${NAME}:${arch}.list" |
53ea1b56 | 950 | else |
63c71412 | 951 | echo -n > "${INFO}/${NAME}.list" |
53ea1b56 | 952 | fi |
d67004e0 | 953 | done |
dfc2b1be DK |
954 | } |
955 | ||
956 | ||
ce9864a8 | 957 | buildaptarchivefromincoming() { |
63c71412 | 958 | msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on incoming packages…" |
ce9864a8 DK |
959 | cd aptarchive |
960 | [ -e pool ] || ln -s ../incoming pool | |
961 | [ -e ftparchive.conf ] || createaptftparchiveconfig | |
962 | [ -e dists ] || buildaptftparchivedirectorystructure | |
b7899b00 | 963 | msgninfo "\tGenerate Packages, Sources and Contents files… " |
31be38d2 | 964 | testsuccess aptftparchive generate ftparchive.conf |
ce9864a8 DK |
965 | cd - > /dev/null |
966 | msgdone "info" | |
4dbfe436 | 967 | generatereleasefiles "$@" |
ce9864a8 DK |
968 | } |
969 | ||
970 | buildaptarchivefromfiles() { | |
63c71412 | 971 | msginfo "Build APT archive for ${CCMD}${0##*/}${CINFO} based on prebuild files…" |
8d041b4f DK |
972 | local DIR='aptarchive' |
973 | if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi | |
974 | find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do | |
9b78cda6 | 975 | msgninfo "\t${line} file… " |
276e51dd | 976 | compressfile "$line" "$1" |
8d876415 | 977 | msgdone "info" |
9b78cda6 | 978 | done |
e3c62328 | 979 | generatereleasefiles "$@" |
9b78cda6 DK |
980 | } |
981 | ||
276e51dd | 982 | compressfile() { |
bdc42211 | 983 | while read compressor extension command; do |
276e51dd DK |
984 | if [ "$compressor" = '.' ]; then |
985 | if [ -n "$2" ]; then | |
986 | touch -d "$2" "$1" | |
987 | fi | |
988 | continue | |
989 | fi | |
990 | cat "$1" | $command > "${1}.${extension}" | |
991 | if [ -n "$2" ]; then | |
992 | touch -d "$2" "${1}.${extension}" | |
993 | fi | |
bdc42211 | 994 | done < "${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf" |
276e51dd DK |
995 | } |
996 | ||
a3bbbab7 | 997 | # can be overridden by testcases for their pleasure |
bf9e7447 DK |
998 | getcodenamefromsuite() { |
999 | case "$1" in | |
1000 | unstable) echo 'sid';; | |
1001 | *) echo -n "$1";; | |
1002 | esac | |
1003 | } | |
a3bbbab7 | 1004 | getreleaseversionfromsuite() { true; } |
718f797c | 1005 | getlabelfromsuite() { true; } |
d56e2917 | 1006 | getoriginfromsuite() { true; } |
1dd20368 | 1007 | getarchitecturesfromreleasefile() { echo "all $(getarchitectures)"; } |
a3bbbab7 | 1008 | |
c5ede4ca DK |
1009 | aptftparchiverelease() { |
1010 | aptftparchive -qq release "$@" | sed -e '/0 Release$/ d' # remove the self reference | |
1011 | } | |
9b78cda6 | 1012 | generatereleasefiles() { |
884a4c0a DK |
1013 | # $1 is the Date header and $2 is the ValidUntil header to be set |
1014 | # both should be given in notation date/touch can understand | |
1dd20368 DK |
1015 | local DATE="$1" |
1016 | local VALIDUNTIL="$2" | |
9b78cda6 | 1017 | if [ -e aptarchive/dists ]; then |
87d6947d | 1018 | msgninfo "\tGenerate Release files for dists… " |
9b78cda6 | 1019 | for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do |
1dd20368 | 1020 | local ARCHITECTURES="$(getarchitecturesfromreleasefile "$dir")" |
a3bbbab7 DK |
1021 | local SUITE="$(echo "$dir" | cut -d'/' -f 4)" |
1022 | local CODENAME="$(getcodenamefromsuite $SUITE)" | |
1023 | local VERSION="$(getreleaseversionfromsuite $SUITE)" | |
718f797c | 1024 | local LABEL="$(getlabelfromsuite $SUITE)" |
d56e2917 | 1025 | local ORIGIN="$(getoriginfromsuite $SUITE)" |
63c71412 | 1026 | aptftparchiverelease "$dir" \ |
884a4c0a DK |
1027 | -o APT::FTPArchive::Release::Suite="${SUITE}" \ |
1028 | -o APT::FTPArchive::Release::Codename="${CODENAME}" \ | |
bc7a59dd DK |
1029 | -o APT::FTPArchive::Release::Architectures="${ARCHITECTURES}" \ |
1030 | -o APT::FTPArchive::Release::Label="${LABEL}" \ | |
1031 | -o APT::FTPArchive::Release::Origin="${ORIGIN}" \ | |
1032 | -o APT::FTPArchive::Release::Version="${VERSION}" \ | |
63c71412 | 1033 | > "$dir/Release" |
a3bbbab7 | 1034 | if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then |
35faae11 | 1035 | sed -i '/^Date: / a\ |
63c71412 | 1036 | NotAutomatic: yes' "$dir/Release" |
35faae11 | 1037 | fi |
9b78cda6 DK |
1038 | done |
1039 | else | |
87d6947d | 1040 | msgninfo "\tGenerate Release files for flat… " |
c5ede4ca | 1041 | aptftparchiverelease ./aptarchive > aptarchive/Release |
8d876415 | 1042 | fi |
1dd20368 | 1043 | if [ -n "$DATE" -a "$DATE" != "now" ]; then |
fe0f7911 | 1044 | for release in $(find ./aptarchive -name 'Release'); do |
0b45b6e5 | 1045 | sed -i "s/^Date: .*$/Date: $(date -u -d "$DATE" -R)/" "$release" |
1dd20368 | 1046 | touch -d "$DATE" "$release" |
fe0f7911 | 1047 | done |
8d876415 | 1048 | fi |
1dd20368 | 1049 | if [ -n "$VALIDUNTIL" ]; then |
c5ede4ca | 1050 | sed -i "/^Date: / a\ |
0b45b6e5 | 1051 | Valid-Until: $(date -u -d "$VALIDUNTIL" -R)" $(find ./aptarchive -name 'Release') |
c5ede4ca | 1052 | fi |
b7899b00 | 1053 | msgdone "info" |
8d876415 DK |
1054 | } |
1055 | ||
b7899b00 | 1056 | setupdistsaptarchive() { |
63c71412 | 1057 | local APTARCHIVE="$(readlink -f ./aptarchive | sed 's# #%20#g')" |
b7899b00 DK |
1058 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list |
1059 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list | |
1060 | for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do | |
63c71412 | 1061 | SECTIONS=$(find "./aptarchive/dists/${DISTS}/" -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ') |
b7899b00 | 1062 | msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… " |
63c71412 DK |
1063 | echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list" |
1064 | echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > "rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list" | |
b7899b00 DK |
1065 | msgdone "info" |
1066 | done | |
1067 | } | |
1068 | ||
1069 | setupflataptarchive() { | |
63c71412 DK |
1070 | local APTARCHIVE="$(readlink -f ./aptarchive)" |
1071 | local APTARCHIVEURI="$(readlink -f ./aptarchive | sed 's# #%20#g')" | |
1072 | if [ -f "${APTARCHIVE}/Packages" ]; then | |
8d876415 | 1073 | msgninfo "\tadd deb sources.list line… " |
63c71412 DK |
1074 | echo "deb file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list' |
1075 | msgdone 'info' | |
8d876415 | 1076 | else |
63c71412 | 1077 | rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list' |
8d876415 | 1078 | fi |
63c71412 | 1079 | if [ -f "${APTARCHIVE}/Sources" ]; then |
8d876415 | 1080 | msgninfo "\tadd deb-src sources.list line… " |
63c71412 DK |
1081 | echo "deb-src file://$APTARCHIVEURI /" > 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list' |
1082 | msgdone 'info' | |
8d876415 | 1083 | else |
63c71412 | 1084 | rm -f 'rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list' |
8d876415 | 1085 | fi |
b7899b00 DK |
1086 | } |
1087 | ||
1088 | setupaptarchive() { | |
4dbfe436 DK |
1089 | local NOUPDATE=0 |
1090 | if [ "$1" = '--no-update' ]; then | |
1091 | NOUPDATE=1 | |
1092 | shift | |
1093 | fi | |
1094 | buildaptarchive "$@" | |
b7899b00 DK |
1095 | if [ -e aptarchive/dists ]; then |
1096 | setupdistsaptarchive | |
1097 | else | |
1098 | setupflataptarchive | |
1099 | fi | |
9d653a6d | 1100 | signreleasefiles 'Joe Sixpack' |
4dbfe436 | 1101 | if [ "1" != "$NOUPDATE" ]; then |
5684f71f | 1102 | testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true |
b2ea1a47 | 1103 | fi |
8d876415 DK |
1104 | } |
1105 | ||
f213b6ea | 1106 | signreleasefiles() { |
fb7b11eb | 1107 | local SIGNERS="${1:-Joe Sixpack}" |
07cb47e7 | 1108 | local REPODIR="${2:-aptarchive}" |
1af227c2 DK |
1109 | if [ -n "$1" ]; then shift; fi |
1110 | if [ -n "$1" ]; then shift; fi | |
fb7b11eb DK |
1111 | local KEY="keys/$(echo "$SIGNERS" | tr 'A-Z' 'a-z' | tr -d ' ,')" |
1112 | msgninfo "\tSign archive with $SIGNERS key $KEY… " | |
29a59c46 DK |
1113 | local REXKEY='keys/rexexpired' |
1114 | local SECEXPIREBAK="${REXKEY}.sec.bak" | |
1115 | local PUBEXPIREBAK="${REXKEY}.pub.bak" | |
fb7b11eb DK |
1116 | local SIGUSERS="" |
1117 | while [ -n "${SIGNERS%%,*}" ]; do | |
1118 | local SIGNER="${SIGNERS%%,*}" | |
1119 | if [ "${SIGNERS}" = "${SIGNER}" ]; then | |
1120 | SIGNERS="" | |
1121 | fi | |
1122 | SIGNERS="${SIGNERS#*,}" | |
1123 | # FIXME: This should be the full name, but we can't encode the space properly currently | |
1124 | SIGUSERS="${SIGUSERS} -u ${SIGNER#* }" | |
1125 | if [ "${SIGNER}" = 'Rex Expired' ]; then | |
1126 | # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time | |
1127 | # option doesn't exist anymore (and using faketime would add a new obscure dependency) | |
1128 | # therefore we 'temporary' make the key not expired and restore a backup after signing | |
1129 | cp "${REXKEY}.sec" "$SECEXPIREBAK" | |
1130 | cp "${REXKEY}.pub" "$PUBEXPIREBAK" | |
1131 | local SECUNEXPIRED="${REXKEY}.sec.unexpired" | |
1132 | local PUBUNEXPIRED="${REXKEY}.pub.unexpired" | |
1133 | if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then | |
1134 | cp "$SECUNEXPIRED" "${REXKEY}.sec" | |
1135 | cp "$PUBUNEXPIRED" "${REXKEY}.pub" | |
1136 | else | |
1137 | if ! printf "expire\n1w\nsave\n" | aptkey --quiet --keyring "${REXKEY}.pub" --secret-keyring "${REXKEY}.sec" \ | |
1138 | --readonly adv --batch --yes --digest-algo "${APT_TESTS_DIGEST_ALGO:-SHA512}" \ | |
1139 | --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then | |
1140 | cat setexpire.gpg | |
1141 | exit 1 | |
1142 | fi | |
1143 | cp "${REXKEY}.sec" "$SECUNEXPIRED" | |
1144 | cp "${REXKEY}.pub" "$PUBUNEXPIRED" | |
f1e1abd8 | 1145 | fi |
29a59c46 | 1146 | fi |
fb7b11eb DK |
1147 | if [ ! -e "${KEY}.pub" ]; then |
1148 | local K="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | tr -d ' ,')" | |
1149 | cat "${K}.pub" >> "${KEY}.new.pub" | |
1150 | cat "${K}.sec" >> "${KEY}.new.sec" | |
1151 | fi | |
1152 | done | |
1153 | if [ ! -e "${KEY}.pub" ]; then | |
1154 | mv "${KEY}.new.pub" "${KEY}.pub" | |
1155 | mv "${KEY}.new.sec" "${KEY}.sec" | |
29a59c46 | 1156 | fi |
fb7b11eb | 1157 | local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes --digest-algo ${APT_TESTS_DIGEST_ALGO:-SHA512}" |
63c71412 | 1158 | for RELEASE in $(find "${REPODIR}/" -name Release); do |
e3c62328 | 1159 | # we might have set a specific date for the Release file, so copy it |
761a5ad2 DK |
1160 | local DATE="$(stat --format "%y" "${RELEASE}")" |
1161 | if [ "$APT_DONT_SIGN" = 'Release.gpg' ]; then | |
1162 | rm -f "${RELEASE}.gpg" | |
1163 | else | |
1164 | testsuccess $GPG "$@" $SIGUSERS --armor --detach-sign --sign --output "${RELEASE}.gpg" "${RELEASE}" | |
1165 | touch -d "$DATE" "${RELEASE}.gpg" | |
1166 | fi | |
1167 | local INRELEASE="${RELEASE%/*}/InRelease" | |
1168 | if [ "$APT_DONT_SIGN" = 'InRelease' ]; then | |
1169 | rm -f "$INRELEASE" | |
1170 | else | |
1171 | testsuccess $GPG "$@" $SIGUSERS --clearsign --output "$INRELEASE" "$RELEASE" | |
1172 | touch -d "$DATE" "${INRELEASE}" | |
1173 | fi | |
f213b6ea | 1174 | done |
29a59c46 | 1175 | if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then |
63c71412 DK |
1176 | mv -f "$SECEXPIREBAK" "${REXKEY}.sec" |
1177 | mv -f "$PUBEXPIREBAK" "${REXKEY}.pub" | |
29a59c46 | 1178 | fi |
63c71412 | 1179 | msgdone 'info' |
f213b6ea DK |
1180 | } |
1181 | ||
8eafc759 | 1182 | redatereleasefiles() { |
0b45b6e5 | 1183 | local DATE="$(date -u -d "$1" -R)" |
8eafc759 | 1184 | for release in $(find aptarchive/ -name 'Release'); do |
63c71412 DK |
1185 | sed -i "s/^Date: .*$/Date: ${DATE}/" "$release" |
1186 | touch -d "$DATE" "$release" | |
8eafc759 DK |
1187 | done |
1188 | signreleasefiles "${2:-Joe Sixpack}" | |
1189 | } | |
1190 | ||
f2c0ec8b | 1191 | webserverconfig() { |
6c0765c0 | 1192 | local WEBSERVER="${3:-http://localhost:${APTHTTPPORT}}" |
b0314abb DK |
1193 | local NOCHECK=false |
1194 | if [ "$1" = '--no-check' ]; then | |
1195 | NOCHECK=true | |
1196 | shift | |
1197 | fi | |
0d58c26a | 1198 | local DOWNLOG='rootdir/tmp/download-testfile.log' |
b0314abb | 1199 | local STATUS='downloaded/webserverconfig.status' |
0d58c26a | 1200 | rm -f "$STATUS" "$DOWNLOG" |
6c0765c0 | 1201 | # very very basic URI encoding |
b0314abb DK |
1202 | local URI |
1203 | if [ -n "$2" ]; then | |
1204 | msgtest "Set webserver config option '${1}' to" "$2" | |
6c0765c0 | 1205 | URI="${WEBSERVER}/_config/set/$(echo "${1}" | sed -e 's/\//%2f/g')/$(echo "${2}" | sed -e 's/\//%2f/g')" |
b0314abb DK |
1206 | else |
1207 | msgtest 'Clear webserver config option' "${1}" | |
6c0765c0 | 1208 | URI="${WEBSERVER}/_config/clear/$(echo "${1}" | sed -e 's/\//%2f/g')" |
b0314abb DK |
1209 | fi |
1210 | if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then | |
f2c0ec8b DK |
1211 | msgpass |
1212 | else | |
68042532 DK |
1213 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output" |
1214 | cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true | |
1215 | msgfailoutput '' "$OUTPUT" | |
f2c0ec8b | 1216 | fi |
b0314abb | 1217 | $NOCHECK || testwebserverlaststatuscode '200' |
f2c0ec8b DK |
1218 | } |
1219 | ||
fd46d305 | 1220 | rewritesourceslist() { |
63c71412 | 1221 | local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')" |
af9e40c9 | 1222 | local APTARCHIVE2="copy://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive" | sed 's# #%20#g')" |
fd46d305 | 1223 | for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do |
af9e40c9 | 1224 | sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#$APTARCHIVE2#${1}#" \ |
28b2efcb DK |
1225 | -e "s#http://[^@]*@\?localhost:${APTHTTPPORT}/\?#${1}#" \ |
1226 | -e "s#https://[^@]*@\?localhost:${APTHTTPSPORT}/\?#${1}#" | |
fd46d305 DK |
1227 | done |
1228 | } | |
1229 | ||
5572f6bd MV |
1230 | # wait for up to 10s for a pid file to appear to avoid possible race |
1231 | # when a helper is started and dosn't write the PID quick enough | |
1232 | waitforpidfile() { | |
1233 | local PIDFILE="$1" | |
1234 | for i in $(seq 10); do | |
1235 | if test -s "$PIDFILE"; then | |
1236 | return 0 | |
1237 | fi | |
1238 | sleep 1 | |
1239 | done | |
1240 | msgdie "waiting for $PIDFILE failed" | |
1241 | return 1 | |
1242 | } | |
1243 | ||
f213b6ea | 1244 | changetowebserver() { |
6c0765c0 | 1245 | local REWRITE='no' |
23af9f40 | 1246 | if [ "$1" != '--no-rewrite' ]; then |
6c0765c0 | 1247 | REWRITE='yes' |
23af9f40 DK |
1248 | else |
1249 | shift | |
1250 | fi | |
63c71412 | 1251 | if test -x "${APTWEBSERVERBINDIR}/aptwebserver"; then |
fbd29dd6 | 1252 | cd aptarchive |
a0db467c | 1253 | local LOG="webserver.log" |
6c0765c0 | 1254 | if ! aptwebserver --port 0 -o aptwebserver::fork=1 -o aptwebserver::portfile='aptwebserver.port' "$@" >$LOG 2>&1 ; then |
3abb6a6a | 1255 | cat "$LOG" |
bee0670b DK |
1256 | false |
1257 | fi | |
6c0765c0 | 1258 | waitforpidfile aptwebserver.pid |
e3c62328 DK |
1259 | local PID="$(cat aptwebserver.pid)" |
1260 | if [ -z "$PID" ]; then | |
1261 | msgdie 'Could not fork aptwebserver successfully' | |
1262 | fi | |
1263 | addtrap "kill $PID;" | |
6c0765c0 DK |
1264 | waitforpidfile aptwebserver.port |
1265 | APTHTTPPORT="$(cat aptwebserver.port)" | |
1266 | if [ -z "$APTHTTPPORT" ]; then | |
1267 | msgdie 'Could not get port for aptwebserver successfully' | |
1268 | fi | |
fbd29dd6 | 1269 | cd - > /dev/null |
c5bcc607 | 1270 | else |
3d284148 | 1271 | msgdie 'You have to build apt from source to have test/interactive-helper/aptwebserver available for tests requiring a webserver' |
f213b6ea | 1272 | fi |
6c0765c0 DK |
1273 | if [ "$REWRTE" != 'yes' ]; then |
1274 | rewritesourceslist "http://localhost:${APTHTTPPORT}/" | |
1275 | fi | |
fd46d305 DK |
1276 | } |
1277 | ||
1278 | changetohttpswebserver() { | |
e75e5879 | 1279 | if ! command -v stunnel4 >/dev/null 2>&1; then |
fd46d305 DK |
1280 | msgdie 'You need to install stunnel4 for https testcases' |
1281 | fi | |
1282 | if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then | |
dc95fee1 | 1283 | changetowebserver --no-rewrite "$@" |
fd46d305 DK |
1284 | fi |
1285 | echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid | |
68ba0b7f | 1286 | cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem |
23af9f40 | 1287 | output = /dev/null |
fd46d305 DK |
1288 | |
1289 | [https] | |
6c0765c0 DK |
1290 | accept = 0 |
1291 | connect = $APTHTTPPORT | |
63c71412 | 1292 | " > "${TMPWORKINGDIRECTORY}/stunnel.conf" |
fd46d305 | 1293 | stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf" |
5572f6bd | 1294 | waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid" |
63c71412 | 1295 | local PID="$(cat "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid")" |
5572f6bd MV |
1296 | if [ -z "$PID" ]; then |
1297 | msgdie 'Could not fork stunnel4 successfully' | |
1298 | fi | |
fd46d305 | 1299 | addtrap 'prefix' "kill ${PID};" |
6970f6e6 | 1300 | APTHTTPSPORT="$(lsof -i -n | awk "/^stunnel4 / && \$2 == \"${PID}\" {print \$9; exit; }" | cut -d':' -f 2)" |
6c0765c0 DK |
1301 | webserverconfig 'aptwebserver::port::https' "$APTHTTPSPORT" "https://localhost:${APTHTTPSPORT}" |
1302 | rewritesourceslist "https://localhost:${APTHTTPSPORT}/" | |
f213b6ea DK |
1303 | } |
1304 | ||
c45233ea DK |
1305 | changetocdrom() { |
1306 | mkdir -p rootdir/media/cdrom/.disk | |
1307 | local CD="$(readlink -f rootdir/media/cdrom)" | |
63c71412 DK |
1308 | cat > rootdir/etc/apt/apt.conf.d/00cdrom <<EOF |
1309 | acquire::cdrom::mount "${CD}"; | |
1310 | acquire::cdrom::"${CD}/"::mount "mv ${CD}-unmounted ${CD}"; | |
1311 | acquire::cdrom::"${CD}/"::umount "mv ${CD} ${CD}-unmounted"; | |
1312 | acquire::cdrom::autodetect 0; | |
1313 | EOF | |
1314 | echo -n "$1" > "${CD}/.disk/info" | |
c45233ea DK |
1315 | if [ ! -d aptarchive/dists ]; then |
1316 | msgdie 'Flat file archive cdroms can not be created currently' | |
1317 | return 1 | |
1318 | fi | |
a0975c8d | 1319 | mv aptarchive/dists "$CD" |
63c71412 | 1320 | ln -s "$(readlink -f ./incoming)" "$CD/pool" |
c45233ea | 1321 | find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete |
a0975c8d DK |
1322 | # start with an unmounted disk |
1323 | mv "${CD}" "${CD}-unmounted" | |
1324 | # we don't want the disk to be modifiable | |
bc8f83a5 | 1325 | addtrap 'prefix' "chmod -f -R +w '$(escape_shell "$PWD/rootdir/media/cdrom/dists/")' '$(escape_shell "$PWD/rootdir/media/cdrom-unmounted/dists/")' || true;" |
b0314abb | 1326 | chmod -R 555 rootdir/media/cdrom-unmounted/dists |
c45233ea DK |
1327 | } |
1328 | ||
fd46d305 | 1329 | downloadfile() { |
ed793a19 | 1330 | local PROTO="${1%%:*}" |
27925d82 | 1331 | if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \ |
dcbb364f | 1332 | download-file "$1" "$2" "$3" 2>&1 ; then |
27925d82 DK |
1333 | return 1 |
1334 | fi | |
fd46d305 | 1335 | # only if the file exists the download was successful |
b0314abb | 1336 | if [ -r "$2" ]; then |
fd46d305 DK |
1337 | return 0 |
1338 | else | |
1339 | return 1 | |
1340 | fi | |
1341 | } | |
1342 | ||
f213b6ea | 1343 | checkdiff() { |
03aa0847 | 1344 | local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')" |
8d876415 | 1345 | if [ -n "$DIFFTEXT" ]; then |
0d58c26a DK |
1346 | echo >&2 |
1347 | echo >&2 "$DIFFTEXT" | |
8d876415 DK |
1348 | return 1 |
1349 | else | |
1350 | return 0 | |
1351 | fi | |
1352 | } | |
1353 | ||
22ac12b2 DK |
1354 | testoutputequal() { |
1355 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output" | |
1356 | local COMPAREFILE="$1" | |
1357 | shift | |
63c71412 | 1358 | if "$@" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then |
22ac12b2 DK |
1359 | msgpass |
1360 | else | |
1361 | echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}" | |
1362 | cat "$COMPAREFILE" >>"${OUTPUT}" | |
1363 | msgfailoutput '' "$OUTPUT" "$@" | |
1364 | fi | |
1365 | } | |
1366 | ||
75954ae2 | 1367 | testfileequal() { |
1501a2c9 | 1368 | msggroup 'testfileequal' |
e6a12ff7 DK |
1369 | local MSG='Test for correctness of file' |
1370 | if [ "$1" = '--nomsg' ]; then | |
1371 | MSG='' | |
1372 | shift | |
1373 | fi | |
75954ae2 DK |
1374 | local FILE="$1" |
1375 | shift | |
e6a12ff7 DK |
1376 | if [ -n "$MSG" ]; then |
1377 | msgtest "$MSG" "$FILE" | |
1378 | fi | |
68042532 | 1379 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output" |
75954ae2 | 1380 | if [ -z "$*" ]; then |
22ac12b2 | 1381 | testoutputequal "$FILE" echo -n '' |
75954ae2 | 1382 | else |
22ac12b2 | 1383 | testoutputequal "$FILE" echo "$*" |
75954ae2 | 1384 | fi |
9beb11aa | 1385 | msggroup |
75954ae2 DK |
1386 | } |
1387 | ||
b855a400 | 1388 | testempty() { |
1501a2c9 | 1389 | msggroup 'testempty' |
a66e1837 DK |
1390 | if [ "$1" = '--nomsg' ]; then |
1391 | shift | |
1392 | else | |
1393 | msgtest "Test for no output of" "$*" | |
1394 | fi | |
859093da | 1395 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile" |
a66e1837 | 1396 | if "$@" >"$COMPAREFILE" 2>&1 && test ! -s "$COMPAREFILE"; then |
859093da DK |
1397 | msgpass |
1398 | else | |
22ac12b2 | 1399 | msgfailoutput '' "$COMPAREFILE" "$@" |
859093da | 1400 | fi |
ab25bf1f | 1401 | aptautotest 'testempty' "$@" |
9beb11aa | 1402 | msggroup |
b855a400 | 1403 | } |
63c71412 DK |
1404 | testnotempty() { |
1405 | msggroup 'testnotempty' | |
1406 | msgtest "Test for some output of" "$*" | |
1407 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnotempty.comparefile" | |
1408 | if ("$@" >"$COMPAREFILE" 2>&1 || true) && test -s "$COMPAREFILE"; then | |
1409 | msgpass | |
1410 | else | |
1411 | msgfailoutput '' "$COMPAREFILE" "$@" | |
1412 | fi | |
1413 | aptautotest 'testnotempty' "$@" | |
1414 | msggroup | |
1415 | } | |
b855a400 | 1416 | |
f74a6fa1 | 1417 | testequal() { |
1501a2c9 | 1418 | msggroup 'testequal' |
f74a6fa1 DK |
1419 | local MSG='Test of equality of' |
1420 | if [ "$1" = '--nomsg' ]; then | |
1421 | MSG='' | |
1422 | shift | |
1423 | fi | |
1424 | ||
03938280 | 1425 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile" |
63c71412 | 1426 | echo "$1" > "$COMPAREFILE" |
8d876415 | 1427 | shift |
d2d68aaf | 1428 | |
f74a6fa1 DK |
1429 | if [ -n "$MSG" ]; then |
1430 | msgtest "$MSG" "$*" | |
1431 | fi | |
22ac12b2 | 1432 | testoutputequal "$COMPAREFILE" "$@" |
ab25bf1f | 1433 | aptautotest 'testequal' "$@" |
9beb11aa | 1434 | msggroup |
8d876415 DK |
1435 | } |
1436 | ||
685625bd | 1437 | testequalor2() { |
1501a2c9 | 1438 | msggroup 'testequalor2' |
03938280 DK |
1439 | local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1" |
1440 | local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2" | |
1441 | local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst" | |
63c71412 DK |
1442 | echo "$1" > "$COMPAREFILE1" |
1443 | echo "$2" > "$COMPAREFILE2" | |
685625bd DK |
1444 | shift 2 |
1445 | msgtest "Test for equality OR of" "$*" | |
63c71412 DK |
1446 | "$@" >"$COMPAREAGAINST" 2>&1 || true |
1447 | if checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >/dev/null 2>&1 || \ | |
1448 | checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >/dev/null 2>&1 | |
0d58c26a | 1449 | then |
0caa5a4c DK |
1450 | msgpass |
1451 | else | |
68042532 DK |
1452 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output" |
1453 | echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1 | |
1454 | checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true | |
1455 | echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1 | |
1456 | checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true | |
1457 | msgfailoutput '' "$OUTPUT" | |
0caa5a4c | 1458 | fi |
ab25bf1f | 1459 | aptautotest 'testequalor2' "$@" |
9beb11aa | 1460 | msggroup |
685625bd DK |
1461 | } |
1462 | ||
8d876415 | 1463 | testshowvirtual() { |
1501a2c9 | 1464 | msggroup 'testshowvirtual' |
edc0ef10 | 1465 | local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual" |
8d876415 DK |
1466 | local PACKAGE="$1" |
1467 | shift | |
1468 | while [ -n "$1" ]; do | |
1469 | VIRTUAL="${VIRTUAL} | |
edc0ef10 | 1470 | N: Can't select versions from package '$1' as it is purely virtual" |
8d876415 DK |
1471 | PACKAGE="${PACKAGE} $1" |
1472 | shift | |
1473 | done | |
1474 | msgtest "Test for virtual packages" "apt-cache show $PACKAGE" | |
1475 | VIRTUAL="${VIRTUAL} | |
4bec02c2 | 1476 | N: No packages found" |
03938280 | 1477 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile" |
ea65d079 | 1478 | local ARCH="$(getarchitecture 'native')" |
68042532 DK |
1479 | echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE" |
1480 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output" | |
87d6947d | 1481 | testoutputequal "$COMPAREFILE" aptcache show "$PACKAGE" |
9beb11aa | 1482 | msggroup |
8d876415 DK |
1483 | } |
1484 | ||
1485 | testnopackage() { | |
1501a2c9 | 1486 | msggroup 'testnopackage' |
8d876415 | 1487 | msgtest "Test for non-existent packages" "apt-cache show $*" |
846856f4 | 1488 | local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')" |
8d876415 | 1489 | if [ -n "$SHOWPKG" ]; then |
68042532 DK |
1490 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output" |
1491 | echo "$SHOWPKG" >"$OUTPUT" | |
1492 | msgfailoutput '' "$OUTPUT" | |
0d58c26a DK |
1493 | else |
1494 | msgpass | |
8d876415 | 1495 | fi |
9beb11aa | 1496 | msggroup |
8d876415 | 1497 | } |
bd4a8f51 DK |
1498 | testnosrcpackage() { |
1499 | msggroup 'testnosrcpackage' | |
1500 | msgtest "Test for non-existent source packages" "apt-cache showsrc $*" | |
1501 | local SHOWPKG="$(aptcache showsrc "$@" 2>&1 | grep '^Package: ')" | |
1502 | if [ -n "$SHOWPKG" ]; then | |
1503 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnosrcpackage.output" | |
1504 | echo "$SHOWPKG" >"$OUTPUT" | |
1505 | msgfailoutput '' "$OUTPUT" | |
1506 | else | |
1507 | msgpass | |
1508 | fi | |
1509 | msggroup | |
1510 | } | |
01a6e24c | 1511 | |
ecb777dd | 1512 | testdpkgstatus() { |
1501a2c9 | 1513 | msggroup 'testdpkgstatus' |
ecb777dd DK |
1514 | local STATE="$1" |
1515 | local NR="$2" | |
1516 | shift 2 | |
1517 | msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*" | |
1518 | local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)" | |
1519 | if [ "$PKGS" != $NR ]; then | |
68042532 DK |
1520 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output" |
1521 | echo "$PKGS" >"$OUTPUT" | |
1522 | dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true | |
1523 | msgfailoutput '' "$OUTPUT" | |
0d58c26a DK |
1524 | else |
1525 | msgpass | |
01a6e24c | 1526 | fi |
9beb11aa | 1527 | msggroup |
01a6e24c DK |
1528 | } |
1529 | ||
ecb777dd | 1530 | testdpkginstalled() { |
1501a2c9 | 1531 | msggroup 'testdpkginstalled' |
ecb777dd | 1532 | testdpkgstatus 'ii' "$#" "$@" |
9beb11aa | 1533 | msggroup |
ecb777dd DK |
1534 | } |
1535 | ||
5cf733e1 | 1536 | testdpkgnotinstalled() { |
1501a2c9 | 1537 | msggroup 'testdpkgnotinstalled' |
ecb777dd | 1538 | testdpkgstatus 'ii' '0' "$@" |
9beb11aa | 1539 | msggroup |
01a6e24c | 1540 | } |
ec7f904e DK |
1541 | |
1542 | testmarkedauto() { | |
1501a2c9 | 1543 | msggroup 'testmarkedauto' |
03938280 | 1544 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile" |
ec7f904e DK |
1545 | if [ -n "$1" ]; then |
1546 | msgtest 'Test for correctly marked as auto-installed' "$*" | |
63c71412 | 1547 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE" |
ec7f904e DK |
1548 | else |
1549 | msgtest 'Test for correctly marked as auto-installed' 'no package' | |
63c71412 | 1550 | echo -n > "$COMPAREFILE" |
ec7f904e | 1551 | fi |
22ac12b2 | 1552 | testoutputequal "$COMPAREFILE" aptmark showauto |
9beb11aa | 1553 | msggroup |
ec7f904e | 1554 | } |
7c2cc4a7 | 1555 | testmarkedmanual() { |
1501a2c9 | 1556 | msggroup 'testmarkedmanual' |
7c2cc4a7 DK |
1557 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile" |
1558 | if [ -n "$1" ]; then | |
1559 | msgtest 'Test for correctly marked as manually installed' "$*" | |
63c71412 | 1560 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > "$COMPAREFILE" |
7c2cc4a7 DK |
1561 | else |
1562 | msgtest 'Test for correctly marked as manually installed' 'no package' | |
63c71412 | 1563 | echo -n > "$COMPAREFILE" |
7c2cc4a7 | 1564 | fi |
22ac12b2 | 1565 | testoutputequal "$COMPAREFILE" aptmark showmanual |
9beb11aa | 1566 | msggroup |
7c2cc4a7 | 1567 | } |
89a1aa5d | 1568 | |
742f67ea DK |
1569 | catfile() { |
1570 | if [ "${1##*.}" = 'deb' ]; then | |
1571 | stat >&2 "$1" || true | |
1572 | file >&2 "$1" || true | |
1573 | else | |
1574 | cat >&2 "$1" || true | |
1575 | fi | |
1576 | } | |
e52aad52 | 1577 | msgfailoutput() { |
1501a2c9 | 1578 | msgreportheader 'msgfailoutput' |
e52aad52 DK |
1579 | local MSG="$1" |
1580 | local OUTPUT="$2" | |
1581 | shift 2 | |
b4f91d4d DK |
1582 | local CMD="$1" |
1583 | if [ "$1" = 'grep' -o "$1" = 'tail' -o "$1" = 'head' ]; then | |
68042532 | 1584 | echo >&2 |
e52aad52 DK |
1585 | while [ -n "$2" ]; do shift; done |
1586 | echo "#### Complete file: $1 ####" | |
742f67ea | 1587 | catfile "$1" |
b4f91d4d | 1588 | echo "#### $CMD output ####" |
e52aad52 | 1589 | elif [ "$1" = 'test' ]; then |
68042532 | 1590 | echo >&2 |
e52aad52 DK |
1591 | # doesn't support ! or non-file flags |
1592 | msgfailoutputstatfile() { | |
1593 | local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$' | |
1594 | if expr match "$1" "$FILEFLAGS" >/dev/null; then | |
1595 | echo "#### stat(2) of file: $2 ####" | |
1596 | stat "$2" || true | |
dffc17ba DK |
1597 | if test -d "$2"; then |
1598 | echo "#### The directory contains: $2 ####" | |
1599 | ls >&2 "$2" || true | |
1600 | elif test -e "$2"; then | |
3196dae8 | 1601 | echo "#### Complete file: $2 ####" |
742f67ea | 1602 | catfile "$2" |
3196dae8 | 1603 | fi |
e52aad52 DK |
1604 | fi |
1605 | } | |
1606 | msgfailoutputstatfile "$2" "$3" | |
1607 | while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do | |
1608 | shift 3 | |
1609 | msgfailoutputstatfile "$2" "$3" | |
1610 | done | |
1611 | echo '#### test output ####' | |
6fc2e030 DK |
1612 | elif [ "$1" = 'cmp' ]; then |
1613 | echo >&2 | |
1614 | while [ -n "$2" ]; do | |
1615 | echo "#### Complete file: $2 ####" | |
742f67ea | 1616 | catfile "$2" |
6fc2e030 DK |
1617 | shift |
1618 | done | |
1619 | echo '#### cmp output ####' | |
e52aad52 | 1620 | fi |
742f67ea | 1621 | catfile "$OUTPUT" |
e52aad52 DK |
1622 | msgfail "$MSG" |
1623 | } | |
1624 | ||
671a55ba DK |
1625 | testsuccesswithglobalerror() { |
1626 | local TYPE="$1" | |
1627 | local ERRORS="$2" | |
1628 | shift 2 | |
1629 | msggroup "$TYPE" | |
0440d936 DK |
1630 | if [ "$1" = '--nomsg' ]; then |
1631 | shift | |
1632 | else | |
1633 | msgtest 'Test for successful execution of' "$*" | |
1634 | fi | |
671a55ba | 1635 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/${TYPE}.output" |
63c71412 | 1636 | if "$@" >"${OUTPUT}" 2>&1; then |
4fa34122 | 1637 | if expr match "$1" '^apt.*' >/dev/null; then |
e52aad52 DK |
1638 | if grep -q -E ' runtime error: ' "$OUTPUT"; then |
1639 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
671a55ba | 1640 | elif grep -E "^[${ERRORS}]: " "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then |
3261271e DK |
1641 | if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then |
1642 | if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \ | |
1643 | | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then | |
1644 | msgpass | |
1645 | else | |
1646 | msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@" | |
1647 | fi | |
1648 | else | |
1649 | msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@" | |
1650 | fi | |
671a55ba DK |
1651 | elif [ "$TYPE" = 'testsuccesswithnotice' ]; then |
1652 | if grep -q -E "^N: " "$OUTPUT"; then | |
1653 | msgpass | |
1654 | else | |
1655 | msgfailoutput 'successful run, but output had no notices' "$OUTPUT" "$@" | |
1656 | fi | |
4fa34122 DK |
1657 | else |
1658 | msgpass | |
1659 | fi | |
1660 | else | |
1661 | msgpass | |
1662 | fi | |
1663 | else | |
1664 | local EXITCODE=$? | |
e52aad52 | 1665 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" |
4fa34122 | 1666 | fi |
671a55ba | 1667 | aptautotest "$TYPE" "$@" |
9beb11aa | 1668 | msggroup |
4fa34122 | 1669 | } |
671a55ba DK |
1670 | testsuccesswithnotice() { |
1671 | testsuccesswithglobalerror 'testsuccesswithnotice' 'WE' "$@" | |
1672 | } | |
1673 | testsuccess() { | |
1674 | testsuccesswithglobalerror 'testsuccess' 'NWE' "$@" | |
1675 | } | |
4fa34122 | 1676 | testwarning() { |
1501a2c9 | 1677 | msggroup 'testwarning' |
4fa34122 DK |
1678 | if [ "$1" = '--nomsg' ]; then |
1679 | shift | |
1680 | else | |
1681 | msgtest 'Test for successful execution with warnings of' "$*" | |
1682 | fi | |
25b86db1 | 1683 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" |
63c71412 | 1684 | if "$@" >"${OUTPUT}" 2>&1; then |
1df24acf | 1685 | if expr match "$1" '^apt.*' >/dev/null; then |
e52aad52 DK |
1686 | if grep -q -E ' runtime error: ' "$OUTPUT"; then |
1687 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1688 | elif grep -q -E '^E: ' "$OUTPUT"; then | |
1689 | msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@" | |
4fa34122 | 1690 | elif ! grep -q -E '^W: ' "$OUTPUT"; then |
e52aad52 | 1691 | msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@" |
1df24acf DK |
1692 | else |
1693 | msgpass | |
1694 | fi | |
1695 | else | |
1696 | msgpass | |
1697 | fi | |
0440d936 | 1698 | else |
07cb47e7 | 1699 | local EXITCODE=$? |
68042532 | 1700 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" |
0440d936 | 1701 | fi |
4fa34122 | 1702 | aptautotest 'testwarning' "$@" |
9beb11aa | 1703 | msggroup |
0440d936 | 1704 | } |
0440d936 | 1705 | testfailure() { |
1501a2c9 | 1706 | msggroup 'testfailure' |
0440d936 DK |
1707 | if [ "$1" = '--nomsg' ]; then |
1708 | shift | |
1709 | else | |
889b0072 | 1710 | msgtest 'Test for failure in execution of' "$*" |
0440d936 | 1711 | fi |
03938280 | 1712 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" |
63c71412 | 1713 | if "$@" >"${OUTPUT}" 2>&1; then |
07cb47e7 | 1714 | local EXITCODE=$? |
e52aad52 | 1715 | msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@" |
0440d936 | 1716 | else |
1df24acf DK |
1717 | local EXITCODE=$? |
1718 | if expr match "$1" '^apt.*' >/dev/null; then | |
b0d40854 | 1719 | if [ "$1" = 'aptkey' ]; then |
2fac0dd5 DK |
1720 | if grep -q " Can't check signature: |
1721 | BAD signature from | |
1722 | signature could not be verified" "$OUTPUT"; then | |
b0d40854 DK |
1723 | msgpass |
1724 | else | |
1725 | msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@" | |
1726 | fi | |
1df24acf | 1727 | else |
b0d40854 DK |
1728 | if grep -q -E ' runtime error: ' "$OUTPUT"; then |
1729 | msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@" | |
1730 | elif grep -q -E '==ERROR' "$OUTPUT"; then | |
1731 | msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@" | |
1732 | elif ! grep -q -E '^E: ' "$OUTPUT"; then | |
1733 | msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@" | |
1734 | else | |
1735 | msgpass | |
1736 | fi | |
1df24acf DK |
1737 | fi |
1738 | else | |
1739 | msgpass | |
1740 | fi | |
0440d936 | 1741 | fi |
ab25bf1f | 1742 | aptautotest 'testfailure' "$@" |
9beb11aa | 1743 | msggroup |
0440d936 DK |
1744 | } |
1745 | ||
7414af7f DK |
1746 | testreturnstateequal() { |
1747 | local STATE="$1" | |
671a55ba DK |
1748 | if [ "$STATE" = 'testsuccesswithglobalerror' ]; then |
1749 | local STATE="$2" | |
1750 | local TYPE="$3" | |
7414af7f | 1751 | shift 3 |
671a55ba DK |
1752 | msggroup "${STATE}equal" |
1753 | if [ "$1" != '--nomsg' ]; then | |
1754 | local CMP="$1" | |
1755 | shift | |
1756 | testsuccesswithglobalerror "$STATE" "$TYPE" "$@" | |
1757 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1758 | else | |
1759 | local CMP="$2" | |
1760 | shift 2 | |
1761 | testsuccesswithglobalerror "$STATE" "$TYPE" "$@" | |
1762 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1763 | fi | |
1764 | else | |
1765 | msggroup "${STATE}equal" | |
1766 | if [ "$2" != '--nomsg' ]; then | |
1767 | local CMP="$2" | |
1768 | shift 2 | |
1769 | "$STATE" "$@" | |
1770 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1771 | else | |
1772 | local CMP="$3" | |
1773 | shift 3 | |
1774 | "$STATE" --nomsg "$@" | |
1775 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/${STATE}.output" "$CMP" | |
1776 | fi | |
7414af7f | 1777 | fi |
9beb11aa | 1778 | msggroup |
25b86db1 | 1779 | } |
7414af7f | 1780 | testsuccessequal() { |
671a55ba DK |
1781 | # we compare output, so we know perfectly well about N: |
1782 | testreturnstateequal 'testsuccesswithglobalerror' 'testsuccess' 'WE' "$@" | |
7414af7f | 1783 | } |
25b86db1 | 1784 | testwarningequal() { |
7414af7f | 1785 | testreturnstateequal 'testwarning' "$@" |
25b86db1 DK |
1786 | } |
1787 | testfailureequal() { | |
7414af7f | 1788 | testreturnstateequal 'testfailure' "$@" |
25b86db1 DK |
1789 | } |
1790 | ||
27925d82 | 1791 | testfailuremsg() { |
1501a2c9 | 1792 | msggroup 'testfailuremsg' |
27925d82 DK |
1793 | local CMP="$1" |
1794 | shift | |
1795 | testfailure "$@" | |
1796 | msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings' | |
68042532 | 1797 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile" |
002b1bc4 | 1798 | grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true |
22ac12b2 | 1799 | testoutputequal "$COMPAREFILE" echo "$CMP" |
9beb11aa | 1800 | msggroup |
27925d82 | 1801 | } |
f18f2338 DK |
1802 | testwarningmsg() { |
1803 | msggroup 'testwarningmsg' | |
1804 | local CMP="$1" | |
1805 | shift | |
1806 | testwarning "$@" | |
1807 | msgtest 'Check that the output of the previous warned command has expected' 'warnings' | |
1808 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarningmsg.comparefile" | |
002b1bc4 | 1809 | grep '^\(W\|E\|N\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" > "$COMPAREFILE" 2>&1 || true |
f18f2338 DK |
1810 | testoutputequal "$COMPAREFILE" echo "$CMP" |
1811 | msggroup | |
1812 | } | |
25b86db1 | 1813 | |
de81b2e2 | 1814 | testfilestats() { |
1501a2c9 | 1815 | msggroup 'testfilestats' |
de81b2e2 DK |
1816 | msgtest "Test that file $1 has $2 $3" "$4" |
1817 | if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then | |
5684f71f DK |
1818 | msgpass |
1819 | else | |
68042532 DK |
1820 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output" |
1821 | { | |
1822 | ls -ld "$1" || true | |
1823 | echo -n "stat(1) reports for $2: " | |
1824 | stat --format "$2" "$1" || true | |
1825 | } >"$OUTPUT" 2>&1 | |
1826 | msgfailoutput '' "$OUTPUT" | |
5684f71f | 1827 | fi |
9beb11aa | 1828 | msggroup |
5684f71f | 1829 | } |
de81b2e2 | 1830 | testaccessrights() { |
1501a2c9 | 1831 | msggroup 'testaccessrights' |
de81b2e2 | 1832 | testfilestats "$1" '%a' '=' "$2" |
9beb11aa | 1833 | msggroup |
de81b2e2 | 1834 | } |
5684f71f | 1835 | |
0d58c26a | 1836 | testwebserverlaststatuscode() { |
1501a2c9 | 1837 | msggroup 'testwebserverlaststatuscode' |
0d58c26a | 1838 | local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log' |
03aa0847 | 1839 | local STATUS='downloaded/webserverstatus-statusfile.log' |
0d58c26a DK |
1840 | rm -f "$DOWNLOG" "$STATUS" |
1841 | msgtest 'Test last status code from the webserver was' "$1" | |
6c0765c0 | 1842 | if downloadfile "http://localhost:${APTHTTPPORT}/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then |
0d58c26a DK |
1843 | msgpass |
1844 | else | |
68042532 DK |
1845 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output" |
1846 | { | |
1847 | if [ -n "$2" ]; then | |
1848 | shift | |
1849 | echo >&2 '#### Additionally provided output files contain:' | |
1850 | cat >&2 "$@" | |
1851 | fi | |
1852 | echo >&2 '#### Download log of the status code:' | |
1853 | cat >&2 "$DOWNLOG" | |
1854 | } >"$OUTPUT" 2>&1 | |
1855 | msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT" | |
0d58c26a | 1856 | fi |
9beb11aa | 1857 | msggroup |
0d58c26a DK |
1858 | } |
1859 | ||
19fdf93d | 1860 | mapkeynametokeyid() { |
785cb6fc | 1861 | while [ -n "$1" ]; do |
19fdf93d DK |
1862 | case "$1" in |
1863 | *Joe*|*Sixpack*|newarchive) echo '5A90D141DBAC8DAE';; | |
1864 | *Rex*|*Expired*) echo '4BC0A39C27CE74F9';; | |
1865 | *Marvin*|*Paranoid*) echo 'E8525D47528144E2';; | |
1866 | oldarchive) echo 'FDD2DB85F68C85A3';; | |
1867 | *) echo 'UNKNOWN KEY';; | |
1868 | esac | |
785cb6fc DK |
1869 | shift |
1870 | done | |
1871 | } | |
1872 | testaptkeys() { | |
1873 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/aptkeylist.output" | |
19fdf93d | 1874 | if ! aptkey list --with-colon | grep '^pub' | cut -d':' -f 5 > "$OUTPUT"; then |
785cb6fc DK |
1875 | echo -n > "$OUTPUT" |
1876 | fi | |
19fdf93d | 1877 | testfileequal "$OUTPUT" "$(mapkeynametokeyid "$@")" |
785cb6fc DK |
1878 | } |
1879 | ||
89a1aa5d DK |
1880 | pause() { |
1881 | echo "STOPPED execution. Press enter to continue" | |
1882 | local IGNORE | |
1883 | read IGNORE | |
1884 | } | |
ab25bf1f | 1885 | |
34651385 DK |
1886 | logcurrentarchivedirectory() { |
1887 | find "${TMPWORKINGDIRECTORY}/aptarchive/dists" -type f | while read line; do | |
1888 | stat --format '%U:%G:%a:%n' "$line" | |
1889 | done | sort > "${TMPWORKINGDIRECTORY}/rootdir/var/log/aptgetupdate.before.lst" | |
1890 | } | |
846bc058 | 1891 | listcurrentlistsdirectory() { |
ba6b79bd DK |
1892 | { |
1893 | find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do | |
1894 | stat --format '%U:%G:%a:%n' "$line" | |
1895 | done | |
1896 | find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do | |
1897 | stat --format '%U:%G:%a:%s:%y:%n' "$line" | |
1898 | done | |
1899 | } | sort | |
846bc058 | 1900 | } |
912a6131 | 1901 | forallsupportedcompressors() { |
b2fd8524 | 1902 | rm -f "${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor" |
912a6131 | 1903 | for COMP in $(aptconfig dump 'APT::Compressor' --format '%f%n' | cut -d':' -f 5 | uniq); do |
0179cfa8 | 1904 | if [ -z "$COMP" -o "$COMP" = '.' ]; then continue; fi |
912a6131 DK |
1905 | "$@" "$COMP" |
1906 | done | |
1907 | } | |
846bc058 | 1908 | |
3a8776a3 | 1909 | ### convenience hacks ### |
8fe964f1 DK |
1910 | mkdir() { |
1911 | # creating some directories by hand is a tedious task, so make it look simple | |
6aef1942 DK |
1912 | local PARAMS="$*" |
1913 | if [ "$PARAMS" != "${PARAMS#*rootdir/var/lib/apt/lists}" ]; then | |
8fe964f1 DK |
1914 | # only the last directory created by mkdir is effected by the -m ! |
1915 | command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" | |
1916 | command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" | |
1917 | command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" | |
1918 | touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock" | |
1919 | if [ "$(id -u)" = '0' ]; then | |
1920 | chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" | |
1921 | fi | |
1922 | else | |
1923 | command mkdir "$@" | |
1924 | fi | |
1925 | } | |
1926 | ||
ab25bf1f DK |
1927 | ### The following tests are run by most test methods automatically to check |
1928 | ### general things about commands executed without writing the test every time. | |
1929 | ||
1930 | aptautotest() { | |
c1e202d2 | 1931 | if [ $# -lt 3 ]; then return; fi |
ab25bf1f DK |
1932 | local TESTCALL="$1" |
1933 | local CMD="$2" | |
1934 | local FIRSTOPT="$3" | |
c1e202d2 DK |
1935 | shift 2 |
1936 | for i in "$@"; do | |
1937 | if ! expr match "$i" '^-' >/dev/null 2>&1; then | |
1938 | FIRSTOPT="$i" | |
1939 | break | |
1940 | fi | |
1941 | done | |
1942 | shift | |
896f0ae8 | 1943 | local AUTOTEST="aptautotest_$(echo "${CMD##*/}_${FIRSTOPT}" | tr -d -c 'A-za-z0-9')" |
ab25bf1f | 1944 | if command -v $AUTOTEST >/dev/null; then |
ab25bf1f DK |
1945 | # save and restore the *.output files from other tests |
1946 | # as we might otherwise override them in these automatic tests | |
63c71412 DK |
1947 | rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" |
1948 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" | |
1949 | mkdir "${TMPWORKINGDIRECTORY}/rootdir/tmp" | |
ab25bf1f | 1950 | $AUTOTEST "$TESTCALL" "$@" |
63c71412 DK |
1951 | rm -rf "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest" |
1952 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp" "${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest" | |
1953 | mv "${TMPWORKINGDIRECTORY}/rootdir/tmp-before" "${TMPWORKINGDIRECTORY}/rootdir/tmp" | |
ab25bf1f DK |
1954 | fi |
1955 | } | |
1956 | ||
1957 | aptautotest_aptget_update() { | |
59148d96 DK |
1958 | local TESTCALL="$1" |
1959 | while [ -n "$2" ]; do | |
1960 | if [ "$2" = '--print-uris' ]; then return; fi # simulation mode | |
1961 | shift | |
1962 | done | |
ab25bf1f | 1963 | if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi |
4bb006d1 DK |
1964 | testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755" |
1965 | testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755" | |
ab25bf1f | 1966 | # all copied files are properly chmodded |
63c71412 DK |
1967 | local backupIFS="$IFS" |
1968 | IFS="$(printf "\n\b")" | |
146f7715 | 1969 | for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do |
4bb006d1 | 1970 | testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644" |
ab25bf1f | 1971 | done |
63c71412 | 1972 | IFS="$backupIFS" |
59148d96 | 1973 | if [ "$TESTCALL" = 'testsuccess' ]; then |
146f7715 DK |
1974 | # failure cases can retain partial files and such |
1975 | testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \) | |
1976 | fi | |
34651385 DK |
1977 | if [ -s "${TMPWORKINGDIRECTORY}/rootdir/var/log/aptgetupdate.before.lst" ]; then |
1978 | testfileequal "${TMPWORKINGDIRECTORY}/rootdir/var/log/aptgetupdate.before.lst" \ | |
1979 | "$(find "${TMPWORKINGDIRECTORY}/aptarchive/dists" -type f | while read line; do stat --format '%U:%G:%a:%n' "$line"; done | sort)" | |
1980 | fi | |
ab25bf1f DK |
1981 | } |
1982 | aptautotest_apt_update() { aptautotest_aptget_update "$@"; } | |
d84da499 | 1983 | aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; } |
016bea82 DK |
1984 | |
1985 | testaptautotestnodpkgwarning() { | |
1986 | local TESTCALL="$1" | |
1987 | while [ -n "$2" ]; do | |
6bf93605 DK |
1988 | if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode |
1989 | if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode | |
016bea82 DK |
1990 | shift |
1991 | done | |
70ff288b | 1992 | testfailure grep '^dpkg: warning:.*\(ignor\|unknown\).*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output" |
016bea82 DK |
1993 | } |
1994 | ||
1995 | aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; } | |
1996 | aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; } | |
1997 | aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; } | |
1998 | aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; } | |
1999 | aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; } | |
2000 | aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; } | |
e5c3f3cc DK |
2001 | |
2002 | testaptmarknodefaultsections() { | |
2003 | testfailure grep '^Auto-Installed: 0$' "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/extended_states" | |
2004 | } | |
2005 | aptautotest_aptmark_auto() { testaptmarknodefaultsections "$@"; } | |
2006 | aptautotest_aptmark_manual() { testaptmarknodefaultsections "$@"; } | |
2007 | aptautotest_aptget_markauto() { testaptmarknodefaultsections "$@"; } | |
2008 | aptautotest_aptget_markmanual() { testaptmarknodefaultsections "$@"; } |